SystemOrganization addCategory: #'Widgets-Core'!
SystemOrganization addCategory: #'Widgets-Support'!
SystemOrganization addCategory: #'Widgets-Views'!
SystemOrganization addCategory: #'Widgets-Views-Models'!
SystemOrganization addCategory: #'Widgets-Views-Support'!
SystemOrganization addCategory: #'Widgets-Dialogs'!
SystemOrganization addCategory: #'Widgets-Custom'!

ScrollBar subclass: #UiScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiScrollBar methodsFor: 'initialize' stamp: 'mt 6/16/2010 21:42:19.285'!
initializeMenuButton

	menuButton := nil.! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 6/28/2010 21:31:27.001'!
isWidgetClass

	^ false! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:31:11.159'!
widgetCategory
	
	^ 'Classic Morphs'! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 11:46:11.254'!
widgetClassIcon

	^ nil! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:38:38.799'!
widgetClassName

	^ self name! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 7/16/2010 11:21:42.826'!
widgetProperties
	"Describe custom properties for this type of widget."
	
	^ {}! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 7/16/2010 11:22:50.821'!
widgetPropertiesToIgnore
	"Describe properties that should not appear in the designer."
	
	^ #()! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:21:50.604'!
frameFractions

	self layoutFrame ifNil: [^ 0@0 corner: 1@1].
	^ self layoutFrame leftFraction @ self layoutFrame topFraction
		corner:
		self layoutFrame rightFraction @ self layoutFrame bottomFraction! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:29:01.842'!
frameFractions: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topFraction: aRectangle top;
		bottomFraction: aRectangle bottom;
		leftFraction: aRectangle left;
		rightFraction: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/28/2010 10:48:13.066'!
frameOffsets

	self layoutFrame ifNil: [^ 0@0 corner: 0@0].
	^ (self layoutFrame leftOffset ifNil: [0]) @ (self layoutFrame topOffset ifNil: [0])
		corner:
		(self layoutFrame rightOffset ifNil: [0]) @ (self layoutFrame bottomOffset ifNil: [0])! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:28:56.456'!
frameOffsets: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topOffset: aRectangle top;
		bottomOffset: aRectangle bottom;
		leftOffset: aRectangle left;
		rightOffset: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:38:40.152'!
isUiContainer

	^ false! !

Morph subclass: #UiButton
	instanceVariableNames: 'checkable checked down icon text autoExclusive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButton commentStamp: 'mt 6/20/2010 20:42:54.272' prior: 0!
Abstract button.!

!UiButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:28:38.684'!
widgetCategory
	
	^ 'Buttons'! !

!UiButton class methodsFor: 'properties' stamp: 'mt 10/21/2010 21:57:42.186'!
widgetProperties

	^ {{'Button'. #yourself} -> {
		#icon -> Form.
		#text -> String.
		#checkable -> Boolean.
		#checked -> Boolean.
		#autoExclusive -> Boolean}}! !

!UiButton class methodsFor: 'properties' stamp: 'mt 10/27/2010 10:02:22.273'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' cellPositioning cellSpacing listCentering listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:28:44.532'!
autoExclusive

	^ autoExclusive ifNil: [autoExclusive := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:31:03.542'!
autoExclusive: aBoolean

	autoExclusive == aBoolean ifTrue: [^ self].
	
	autoExclusive := aBoolean.
	
	aBoolean ifTrue: [self checkable: true].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 9/1/2010 12:29:29.321'!
borderStyle: newStyle
	"Removed explicit #changed to use it in the #drawOn: message."
	
	newStyle = self borderStyle ifFalse:[
		(self canDrawBorder: newStyle) ifFalse:[
			"Replace the suggested border with a simple one"
			^self borderStyle: (BorderStyle width: newStyle width color: (newStyle trackColorFrom: self) color)].
		self setProperty: #borderStyle toValue: newStyle].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:52.944'!
checkable

	^ checkable ifNil: [checkable := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:48:57.047'!
checkable: aBoolean

	aBoolean == checkable ifTrue: [^ self].

	checkable := aBoolean.
	
	aBoolean ifFalse: [checked := false].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:46.981'!
checked

	^ checked ifNil: [checked := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:10:10.273'!
checked: aBoolean

	(aBoolean == checked or: [self checkable not])
		ifTrue: [^ self].	
	
	checked := aBoolean.
	
	self toggled: aBoolean.
	
	self redrawLater.
	
	"Handle auto-exclusiveness."
	(self autoExclusive and: [self checked])
		ifTrue: [self owner ifNotNil: [:group |
			group submorphs
				select: [:m | (m isKindOf: UiButton) and: [m ~= self]]
				thenDo: [:m | m checked: false]]].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:35:59.853'!
clicked: isChecked

	self emit.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:42.188'!
down

	^ down ifNil: [down := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 21:21:04.758'!
down: aBoolean

	aBoolean == down ifTrue: [^ self].
	
	down := aBoolean.
	
	self redrawLater.
	
	aBoolean
		ifFalse: [self toggle].! !

!UiButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 19:02:44.381'!
gradient
	"Generate a gradient based on the current color and geometry."

	| inverted |
	inverted := self down or: [self checked].
	^ (GradientFillStyle ramp: {
			0.0 -> (self color adjustBrightness: 0.1).
			0.1-> (self color adjustBrightness: 0.05).
			0.6 -> (self color darker)})
		origin: (inverted
			ifTrue: [self innerBounds bottomLeft]
			ifFalse: [self innerBounds topLeft]);
		direction: (inverted
			ifTrue: [0 @ self innerBounds height negated]
			ifFalse: [0 @ self innerBounds height]).! !

!UiButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 19:42:16.326'!
handlesMouseDown: evt

	^ true! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:04.67'!
icon

	^ icon! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:07:08.152'!
icon: aForm

	icon := aForm.! !

!UiButton methodsFor: 'initialization' stamp: 'mt 6/20/2010 20:42:04.965'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.8);
		borderColor: (Color gray: 0.3);
		borderWidth: 1;
		extent: 50@25.! !

!UiButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 21:21:37.315'!
mouseDown: evt

	self
		down: true;
		pressed.! !

!UiButton methodsFor: 'event handling' stamp: 'mt 7/11/2010 09:13:56.79'!
mouseUp: evt

	(self bounds containsPoint: evt position)
		ifTrue: [self down: false; released; clicked: self checked]
		ifFalse: [down := false. self redrawLater].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:09.523'!
pressed

	self emit.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:14.649'!
released

	self emit.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:55.971'!
text

	^ text! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:05:52.788'!
text: aStringOrText

	text := aStringOrText.! !

!UiButton methodsFor: 'actions' stamp: 'mt 6/21/2010 10:39:00.668'!
toggle

	(self autoExclusive and: [self checked])
		ifTrue: ["Must not toggle." ^ self].
	
	self checked: self checked not.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:30.246'!
toggled: isChecked

	self emit.! !

UiButton subclass: #UiCheckBox
	instanceVariableNames: 'box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiCheckBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 10:04:30.463'!
isWidgetClass

	^ true! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:45:56.946'!
widgetClassIcon

	^ UiFugueIcons uiCheckBoxesIcon! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:28.921'!
widgetClassName

	^ 'Check Box'! !

!UiCheckBox class methodsFor: 'properties' stamp: 'mt 10/28/2010 09:51:08.562'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #('checkable')! !

!UiCheckBox methodsFor: 'accessing' stamp: 'mt 10/28/2010 10:20:18.386'!
checked: aBoolean

	super checked: aBoolean.
	box ifNotNil: [:b | b checked: aBoolean].! !

!UiCheckBox methodsFor: 'drawing' stamp: 'mt 6/29/2010 10:25:13.039'!
drawOn: aCanvas

	"Invisible."! !

!UiCheckBox methodsFor: 'drawing' stamp: 'mt 6/29/2010 10:34:46.299'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	box notNil & self checked ifTrue: [
		aCanvas
			line: box topLeft + (0@(box height // 2)) + (2@0)
			to: box bottomLeft + ((box width // 2)@0) - (0@2)
			width: 2
			color: (Color gray: 0.3).
		aCanvas
			line: box bottomLeft + ((box width // 2)@0) - (0@2)
			to: box topRight - (2@ -2)
			width: 2
			color: (Color gray: 0.3)].! !

!UiCheckBox methodsFor: 'accessing' stamp: 'mt 6/29/2010 10:06:59.035'!
icon: anIcon

	super icon: anIcon.
	self updateSubmorphs.! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 10/28/2010 10:17:59.834'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
		
	self 
		text: 'CheckBox';
		checkable: true;
		updateSubmorphs.
		
	self connect: box signal: #toggled: toSelector: #checked:.! !

!UiCheckBox methodsFor: 'accessing' stamp: 'mt 6/29/2010 10:06:44.04'!
text: aText

	super text: aText.
	self updateSubmorphs.! !

!UiCheckBox methodsFor: 'updating' stamp: 'mt 10/27/2010 10:07:29.688'!
updateSubmorphs

	self	 removeAllMorphs.
	
	box ifNil: [box := UiToolButton new
		checkable: true;
		hResizing: #rigid;
		vResizing: #rigid;
		icon: nil; text: nil;
		extent: 12@12].
	
	self addMorphBack: box.
	self icon ifNotNil: [:i | self addMorphBack: i asMorph].
	self text ifNotNil: [:t | self addMorphBack: t asHtmlText asMorph lock].! !

UiButton subclass: #UiPushButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiPushButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:57:11.625'!
isWidgetClass

	^ true! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:49:23.805'!
widgetClassIcon

	^ UiFugueIcons uiButtonIcon! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:10:37.376'!
widgetClassName

	^ 'Push Button'! !

!UiPushButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 18:59:07.342'!
drawOn: aCanvas

	| currentColor |
	currentColor := self color.
	
	self borderStyle: (
		(self down or: [self checked])
			ifFalse: [BorderStyle raised width: 1]
			ifTrue: [BorderStyle inset width: 1]).
	
	(self down or: [self checked])
		ifTrue: [color := currentColor darker].
	
	self setProperty: #fillStyle toValue: self gradient.
	
	super drawOn: aCanvas.
	
	color := currentColor.
	
	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: 1
		color: self color muchDarker.! !

!UiPushButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 18:55:11.925'!
drawSubmorphsOn: aCanvas

	aCanvas
		translateBy: ((self down or: [self checked])
			ifTrue: [1@1]
			ifFalse: [0@0])
		during: [:c | super drawSubmorphsOn: c].! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:03:25.81'!
icon: aForm

	super icon: aForm.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:23.131'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		text: 'PushButton';
		updateSubmorphs.! !

!UiPushButton methodsFor: 'geometry' stamp: 'mt 6/28/2010 21:57:58.205'!
outerBounds
	"Used for extra outline. See #draw."
	
	^ self bounds outsetBy: (1@1 corner: 1@1)! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:03:18.543'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'updating' stamp: 'mt 10/27/2010 10:06:18.529'!
updateSubmorphs

	self	 removeAllMorphs.
		
	self icon ifNotNil: [:i | self addMorphBack: i asMorph].
	self text ifNotNil: [:t | self addMorphBack: t asHtmlText asMorph lock].! !

UiButton subclass: #UiToolButton
	instanceVariableNames: 'raised autoRaise buttonStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiToolButton commentStamp: 'mt 6/20/2010 20:42:44.027' prior: 0!
Supports auto raise and aligns icon and text automatically.!

!UiToolButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:32:01.69'!
isWidgetClass

	^ true! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:15.247'!
widgetClassIcon

	^ UiFugueIcons uiButtonToggleIcon! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:11:24.018'!
widgetClassName

	^ 'Tool Button'! !

!UiToolButton class methodsFor: 'properties' stamp: 'mt 10/22/2010 11:40:45.982'!
widgetProperties

	^ super widgetProperties, {{'Tool Button'. #yourself} -> {
		#autoRaise -> Boolean.
		#buttonStyle -> #(iconOnly textOnly textBesideIcon textUnderIcon)}}! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:08:09.225'!
autoRaise

	^ autoRaise ifNil: [autoRaise := false]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:36:20.019'!
autoRaise: aBoolean

	aBoolean == autoRaise ifTrue: [^ self].

	autoRaise := aBoolean.
	
	self raised: aBoolean not.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:36:21.335'!
buttonStyle

	^ buttonStyle ifNil: [buttonStyle := #textBesideIcon]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:37:57.741'!
buttonStyle: aStyle
	"#iconOnly #textOnly #textBesideIcon #textUnderIcon"

	aStyle = buttonStyle ifTrue: [^ self].
	
	buttonStyle := aStyle.
	
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 19:06:35.628'!
drawOn: aCanvas

	| currentColor |
	currentColor := self color.
	
	self borderStyle: (
		(self down or: [self checked])
			ifFalse: [(self autoRaise not or: [self raised]) ifTrue: [BorderStyle raised width: 1] ifFalse: [nil]]
			ifTrue: [BorderStyle inset width: 1]).
	
	(self down or: [self checked])
		ifTrue: [color := currentColor darker].
	
	(self autoRaise not or: [self raised])
		ifTrue: [self setProperty: #fillStyle toValue: self gradient]
		ifFalse: [self removeProperty: #fillStyle].
	
	super drawOn: aCanvas.
	
	color := currentColor.	! !

!UiToolButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 19:00:18.669'!
drawSubmorphsOn: aCanvas

	aCanvas
		translateBy: ((self down or: [self checked])
			ifTrue: [1@1]
			ifFalse: [0@0])
		during: [:c | super drawSubmorphsOn: c].! !

!UiToolButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 20:10:34.3'!
handlesMouseOver: evt

	^ true! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:16:36.279'!
icon: aForm

	super icon: aForm.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:39.179'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		raised: true;
		text: 'ToolButton';
		updateSubmorphs.! !

!UiToolButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 20:22:29.484'!
mouseEnter: evt

	self autoRaise ifTrue: [self raised: true].! !

!UiToolButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 20:22:33.945'!
mouseLeave: evt

	self autoRaise ifTrue: [self raised: false].! !

!UiToolButton methodsFor: 'event handling' stamp: 'mt 6/20/2010 20:46:45.585'!
mouseUp: evt

	(self bounds containsPoint: evt position)
		ifFalse: [self autoRaise ifTrue: [self raised: false]].
		
	super mouseUp: evt.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:20:48.182'!
raised

	^ raised ifNil: [raised := true]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:55:53.198'!
raised: aBoolean

	aBoolean == raised ifTrue: [^ self].

	raised := aBoolean.
	self redrawLater.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:16:46.914'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'updating' stamp: 'mt 10/27/2010 10:06:32.508'!
updateSubmorphs

	self	 removeAllMorphs.
	
	self buttonStyle = #textUnderIcon
		ifTrue: [self listDirection: #topToBottom]
		ifFalse: [self listDirection: #leftToRight].
	
	self icon ifNotNil: [:i | (self buttonStyle ~= #textOnly 
		or: [self text isNil]) ifTrue: [self addMorphBack: i asMorph]].
	self text ifNotNil: [:t | (self buttonStyle ~= #iconOnly
		or: [self icon isNil]) ifTrue: [self addMorphBack: t asHtmlText asMorph lock]].! !

Morph subclass: #UiComboBox
	instanceVariableNames: 'button readOnlyButton lineEdit listWidget converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiComboBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 16:31:40.618'!
isWidgetClass

	^ true! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:17.438'!
widgetCategory
	
	^ 'Input Widgets'! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:28.366'!
widgetClassIcon

	^ UiFugueIcons uiComboBoxIcon! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:12.475'!
widgetClassName

	^ 'Combo Box'! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 10/21/2010 21:33:54.89'!
widgetProperties

	^ {{'Combo Box'. #yourself} -> {
		#readOnly -> Boolean}}! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 10/27/2010 09:45:15.58'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' vResizing cellPositioning cellSpacing listCentering listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 9/20/2010 13:47:56.238'!
addIcon: anIcon text: aLabel

	listWidget addIcon: anIcon text: aLabel.
	
	listWidget items size = 1
		ifTrue: [self updateCurrentRow: 1]! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 10/14/2010 20:43:12.328'!
addText: aLabel

	listWidget addText: aLabel.
	
	listWidget items size = 1
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'as yet unclassified' stamp: 'mt 10/22/2010 11:21:18.159'!
changed

	self submorphs notEmpty ifTrue: [
		button height ~= self submorphs first
			ifTrue: [button height: self submorphs first height]].
		
	super changed.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:19:31.999'!
clear

	listWidget clear.
	self updateCurrentRow: nil.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:55:55.354'!
color: aColor

	super color: aColor.
	readOnlyButton color: aColor.
	button color: aColor.
	listWidget borderColor: aColor muchDarker.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:53.22'!
converter

	^ converter ifNil: [converter := [:item | item]]! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:11.326'!
converter: aBlock

	converter := aBlock.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 08:19:30.874'!
currentIndex

	^ listWidget currentRow! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/14/2010 20:42:53.745'!
currentIndex: anIndex

	listWidget currentRow: anIndex.
	self updateCurrentRow: anIndex.! !

!UiComboBox methodsFor: 'signals' stamp: 'mt 6/29/2010 17:11:28.048'!
currentIndexChanged: index text: text

	self emit.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:58:02.404'!
currentText

	^ self converter value: lineEdit theText! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:18:07.179'!
drawOn: aCanvas

	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: 1
		color: self color muchDarker.! !

!UiComboBox methodsFor: 'finding' stamp: 'mt 10/20/2010 14:57:44.382'!
findText: aText

	listWidget items withIndexDo: [:item :index | item text = aText ifTrue: [^ index]].
	^ 0! !

!UiComboBox methodsFor: 'private' stamp: 'mt 10/21/2010 20:53:54.591'!
hideList

	listWidget delete.
	
	button checked: false.
	readOnlyButton checked: false.! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 10/21/2010 21:17:53.382'!
initialize

	super initialize.
	
	self
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		width: 150.
		
	button := UiToolButton new
		text: nil;
		checkable: true;
		vResizing: #rigid;
		icon: (UiSilkIcons bulletArrowDownIcon clippedTo: 8@8);
		layoutInset: (3@4 corner: 3@4).
	lineEdit := UiLineEdit new
		outerBorderWidth: 0.
	listWidget := UiListWidget new
		borderWidth: 1.
	
	readOnlyButton := UiToolButton new
		text: ' ';
		icon: nil;
		checkable: true;
		hResizing: #spaceFill.
	
	"Initialize the submorphs the first time."
	self readOnly: true.
		
	self connect: listWidget signal: #currentRowChanged: toSelector: #updateCurrentRow:.
	self connect: listWidget signal: #currentRowChanged: toSelector: #hideList.

	self connect: button signal: #toggled: toSelector: #listVisible:.
	self connect: readOnlyButton signal: #toggled: toSelector: #listVisible:.

	self connect: button signal: #pressed to: readOnlyButton selector: #toggle.
	self connect: readOnlyButton signal: #pressed to: button selector: #toggle.
	
	self color: (Color gray: 0.8).! !

!UiComboBox methodsFor: 'private' stamp: 'mt 6/29/2010 16:48:03.535'!
listVisible: aBoolean

	aBoolean
		ifTrue: [self showList]
		ifFalse: [self hideList].
! !

!UiComboBox methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:16:12.484'!
outerBounds

	^ self bounds outsetBy: (1@1 corner: 1@1)! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:38:37.021'!
readOnly

	^ lineEdit readOnly! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 9/20/2010 13:57:25.853'!
readOnly: aBoolean

	lineEdit readOnly: aBoolean.
	self updateSubmorphs.! !

!UiComboBox methodsFor: 'private' stamp: 'mt 10/24/2010 11:10:53.526'!
showList

	listWidget size = 0 ifTrue: [^ self].
	listWidget owner ifNotNil: [^ self].
	
	listWidget
		useOptimalSize;
		width: (self width + 2 max: listWidget width);
		height: (listWidget height min: 100);
		topLeft: (self localPointToGlobal: self bottomLeft) - (1@0);
		openInWorld;
		fadeIn.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:32.602'!
size

	^ listWidget size! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 10/20/2010 14:15:18.676'!
updateCurrentRow: anIndex

	lineEdit theText: listWidget currentText.
	
	readOnlyButton text: lineEdit theText.
	readOnlyButton icon: listWidget currentIcon.
	
	self currentIndexChanged: anIndex text: (self converter value: lineEdit theText).! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 10/22/2010 11:20:31.02'!
updateSubmorphs

	self removeAllMorphs.
	
	self
		addMorphBack: (self readOnly ifTrue: [readOnlyButton] ifFalse: [lineEdit]);
		addMorphBack: button.! !

Morph subclass: #UiIconPickerDialog
	instanceVariableNames: 'iconSetCombo iconView infoLabel icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiIconPickerDialog commentStamp: 'mt 10/19/2010 11:08:01.295' prior: 0!
A useful dialog to help a developer to choose the right icon.!

!UiIconPickerDialog class methodsFor: 'instance creation' stamp: 'mt 10/14/2010 20:34:30.931'!
open

	self new open.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/21/2010 22:36:14.829'!
changeIconSet: anIndex

	iconView model iconSet: (UiIcons subclasses reversed at: anIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/14/2010 20:47:24.871'!
chooseIcon: aModelIndex

	Clipboard clipboardText: (iconView model codeSnippetFor: aModelIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/21/2010 22:11:41.636'!
chooseIconAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := (iconView model iconFor: aModelIndex).
	self delete.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/22/2010 11:24:25.666'!
chooseIconCodeAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := iconView model codeSnippetFor: aModelIndex.
	self delete.! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:30.318'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self owner == ActiveWorld
		ifTrue: [self drawShadowOn: aCanvas].! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:03.92'!
drawShadowOn: aCanvas

	aCanvas
		line: self topRight + (0@3)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self bottomLeft + (3@0)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self topRight + (1@4)
		to: self bottomRight + (1@0)
		color: (Color black alpha: 0.5).
		
	aCanvas
		line: self bottomLeft + (4@1)
		to: self bottomRight + (0@1)
		color: (Color black alpha: 0.5).! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/21/2010 22:35:05.562'!
initialize

	super initialize.
	
	iconSetCombo := UiComboBox new hResizing: #spaceFill.
	UiIcons subclasses reverseDo: [:s | iconSetCombo addText: s name].
	self connect: iconSetCombo signal: #currentIndexChanged:text: toSelector: #changeIconSet:.
	
	iconView := UiListIconView new
		listOrientation: #vertical;
		model: (UiIconModel new showText: false);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	self connect: iconView signal: #clicked: toSelector: #chooseIcon:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 5;
		cellInset: 5;
		cellPositioning: #topLeft.
		
	self
		addMorphBack: (UiLabel new text: 'Select an icon set then pick an icon below. The code to get
the form will be copied into the <b>clipboard</b>.' asHtmlText);
		addMorphBack: iconSetCombo;
		addMorphBack: iconView.
		
	"Initial set."
	self changeIconSet: iconSetCombo currentIndex.! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/14/2010 20:59:07.38'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Icon Picker')
		extent: 350@300.
		
	self color: c.! !

!UiIconPickerDialog methodsFor: 'geometry' stamp: 'mt 10/22/2010 11:15:55.661'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 2@2)! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:23:55.331'!
pickCodeForIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconCodeAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/21/2010 22:09:52.839'!
pickIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

Morph subclass: #UiItemViewport
	instanceVariableNames: 'rows columns hoveredCell selectionColor selection selectionMode selectionBehavior verticalHeader horizontalHeader rowOrder columnOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/19/2010 10:28:08.197'!
activated: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/13/2010 16:32:59.912'!
addMorph: aMorph atIndex: aModelIndex

	| col row indent |	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self addRowFor: aModelIndex.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items add: aMorph beforeIndex: (rows indexOf: row).
	
	self addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		(col itemBefore: aMorph)
			ifNil: [indent := self indent] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent].
				"The item before is my sibling. Use its indentation."
				(item valueOfProperty: #modelIndex) parent = aModelIndex parent
					ifTrue: [indent := item valueOfProperty: #indent]]].
	aMorph setProperty: #indent toValue: indent.! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 10/14/2010 10:02:41.166'!
addRowFor: aModelIndex
	"Adds a new row if needed. Returns the correct one if possible."
	
	| row isCorrectRow isPreviousSibling isParentRow |
	isCorrectRow := [:r | r parentModelIndex = aModelIndex parent
		and: [r firstModelIndex row = aModelIndex row]].
	isPreviousSibling := [:r | r parentModelIndex = aModelIndex parent 
		and: [r firstModelIndex row = (aModelIndex row - 1)]].
	isParentRow := [:r | r firstModelIndex = aModelIndex parent].
	
	rows reverseDetect: [:r |
		(isCorrectRow value: r)
			ifTrue: [row := r. true]
			ifFalse: [((isPreviousSibling value: r) or: [isParentRow value: r])
				ifTrue: [row := rows add: UiViewRowInfo new after: r. true]
				ifFalse: [false]]
		] ifNone: [row := rows add: UiViewRowInfo new].
	
	^ row! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:48.094'!
cellBoundsFor: aCellIndex

	| col row |
	(aCellIndex x > columns size
		or: [aCellIndex y > rows size])
		ifTrue: [^ 0@0 extent: 0@0].
	
	col := self columnAt: aCellIndex x.
	row := self rowAt: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 09:47:23.765'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| offset cellIndex |
	offset := self topLeft.
	cellIndex := 0@0.
	self columnsDo: [:colInfo |
		cellIndex := cellIndex + (1@0).
		self rowsDo: [:rowInfo |
			cellIndex := cellIndex + (0@1).
			((offset extent: colInfo width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
		offset := (offset x + colInfo width) @ self top.
		cellIndex := cellIndex x @ 0].
	
	^ nil! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/16/2010 08:26:15.478'!
clear

	self selection clear.
	
	columns do: [:colInfo | colInfo clear].
	rows removeAll.
	self removeAllMorphs.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 10:37:48.612'!
click: evt

	| index |
	index := self modelIndexFor: (self cellIndexFromPoint: evt position).
	self
		clicked: index;
		activated: index.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/8/2010 16:05:54.303'!
clicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/14/2010 09:45:01.756'!
collapseRow: aRowInfo

	| foundFirst predecessors |
	foundFirst := false.
	predecessors := {aRowInfo} asOrderedCollection.
	rows
		select: [:row |
			"Find all rows and subrows that need to be removed."
			(predecessors anySatisfy: [:pred | row parentModelIndex = pred firstModelIndex])
				ifTrue: [predecessors add: row. foundFirst := true]
				ifFalse: [foundFirst ifTrue: [predecessors := #()]. false]]
		thenDo: [:row | self removeRow: row].! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:38.765'!
columnAt: index

	index > columns size
		ifTrue: [index - columns size timesRepeat: [columns add: UiViewColumnInfo new]].
	
	^ self columnOrder items: columns at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:57.129'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := self columnAt: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 11:26:53.355'!
columnFor: aModelIndex

	^ columns
		at: aModelIndex column
		ifAbsentPut: [UiViewColumnInfo new]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:57.992'!
columnOrder

	^ columnOrder! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:05.896'!
columnsDo: aBlock

	self columnOrder items: columns do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:10.134'!
columnsWithIndexDo: aBlock

	self columnOrder items: columns withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/20/2010 13:54:10.953'!
currentIndexChanged: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/20/2010 14:05:41.933'!
currentModelIndex

	^ self modelIndexFor: self selection currentCell! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 10:38:09.654'!
doubleClick: evt

	| index |
	index := self modelIndexFor: (self cellIndexFromPoint: evt position).
	self
		doubleClicked: index;
		activated: index.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/8/2010 16:05:00.799'!
doubleClicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 14:30:59.752'!
drawCurrentCellOn: aCanvas

	self selection currentCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self selection currentCell)
			color: self selectionColor darker.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self selection currentCell y)
			color: self selectionColor darker.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self selection currentCell x)
			color: self selectionColor darker.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:34:39.295'!
drawHighlightOn: aCanvas bounds: drawBounds color: aColor
	
	| gradient |

	gradient := (GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (aColor adjustBrightness: 0.05).
			0.6 -> (aColor darker)})
		origin: drawBounds topLeft;
		direction: 0 @ drawBounds height.
		
	aCanvas
		fillRoundRect: (drawBounds insetBy: (1@1 corner: 0@0))
		radius: 3
		fillStyle: gradient;
		frameRoundRect: (drawBounds outsetBy: (0@0 corner: 1@1))
		radius: 3
		width: 1
		color: aColor muchDarker.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:41:13.054'!
drawHoveredCellOn: aCanvas

	self hoveredCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self hoveredCell)
			color: self selectionColor muchLighter.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self hoveredCell y)
			color: self selectionColor muchLighter.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self hoveredCell x)
			color: self selectionColor muchLighter.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:16:54.342'!
drawOn: aCanvas
	
	self
		drawHoveredCellOn: aCanvas;
		drawSelectionOn: aCanvas;
		drawCurrentCellOn: aCanvas.
	super drawOn: aCanvas.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 09:25:33.057'!
drawSelectionOn: aCanvas

	self selectionBehavior = #selectCells ifTrue: [
		self selection cells do: [:cell |
			self
				drawSelectionOn: aCanvas
				bounds: (self cellBoundsFor: cell)	].
			^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		(self selection cells collect: [:cell | cell y]) asSet do: [:rowIndex |
			self
				drawSelectionOn: aCanvas
				bounds: (self rowBoundsFor: rowIndex)].
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		(self selection cells collect: [:cell | cell x]) asSet do: [:colIndex |
			self
				drawSelectionOn: aCanvas
				bounds: (self columnBoundsFor: colIndex)].
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:17:16.138'!
drawSelectionOn: aCanvas bounds: drawBounds
	
	self
		drawHighlightOn: aCanvas
		bounds: drawBounds
		color: self selectionColor.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 20:02:30.608'!
drawSubmorphsOn: aCanvas 
	"Clip in cells. Optimized."
	
	| offset |
	submorphs isEmpty ifTrue: [^self].
	
	offset := self topLeft.
	self columnsWithIndexDo: [:colInfo :colIndex |
		
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex | | rowInfo |
			rowInfo := rows at: rowIndex.
			aCanvas
				clipBy: (offset extent: colInfo width @ rowInfo height)
				during: [:canvas | canvas fullDrawMorph: item].
			
			offset := offset translateBy: 0 @ rowInfo height].
		
		offset := (offset x + colInfo width) @ self top].! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 10/10/2010 13:03:00.575'!
extent: aPoint

	super extent: aPoint.
	self resizedToWidth: aPoint x height: aPoint y.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/11/2010 17:18:00.533'!
focusChanged: aRectangle
	"Indicate that a scrollable container should ensure the given area as visible."
	
	self emit.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:52:42.129'!
handleMouseMove: anEvent

	super handleMouseMove: anEvent.
	
	anEvent wasHandled not
	"	and: [anEvent hand mouseFocus == self])"
		ifTrue: [self mouseMove: anEvent. anEvent wasHandled: true]! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 16:53:44.92'!
handlesKeyboard: evt

	^ true! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/8/2010 15:30:36.577'!
handlesMouseDown: evt

	^ true! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:46:59'!
handlesMouseOver: evt

	^ true! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:05.566'!
horizontalHeader

	^ horizontalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:11.666'!
horizontalHeader: aMorph

	horizontalHeader := aMorph.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:39:13.856'!
hoveredCell

	^ hoveredCell! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 17:13:05.489'!
hoveredCell: aPoint

	aPoint = hoveredCell
		ifTrue: [^ self].
		
	hoveredCell := aPoint.
	self redrawLater.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:01:57.895'!
indent
	"Defines how much items of the first column will be moved to the left for each level - including the first one."
	
	^ 0! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/18/2010 19:06:56.478'!
initialize

	super initialize.
	self color: Color transparent.
		
	rows := OrderedCollection new.
	columns := OrderedCollection new.
	
	rowOrder := UiItemOrder new.
	columnOrder := UiItemOrder new.
	
	self selectionMode: UiViewSingleSelection.! !

!UiItemViewport methodsFor: 'testing' stamp: 'mt 10/14/2010 10:50:19.462'!
isExpanded: aModelIndex

	^ aModelIndex isNil "the root is always expanded"
		or: [(self rowFor: aModelIndex) isExpanded]! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 10:36:53.34'!
keyStroke: evt

	| cc |
	cc := self selection currentCell.
	
	(({Character cr. Character lf. Character enter} includes: evt keyCharacter)
		and: [cc notNil])
		ifTrue: [self activated: cc].

	"Manuall navigation."
	cc ifNil: [^ self selection add: 1@1 event: evt].

	evt keyCharacter = Character arrowUp
		ifTrue: [self selection add: (cc - (0@1) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self selection add: (cc + (0@1) min: (columns size @ rows size) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self selection add: (cc - (1@0) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self selection add: (cc + (1@0) min: (columns size @ rows size) max: 1@1) event: evt].! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:37.763'!
leftForColumn: aColumnInfo

	| result |
	result := self left.
	self columnsDo: [:col |
		col = aColumnInfo ifTrue: [^ result].
		result := result + col width].
	
	Error signal: 'Column info not found!!'.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 09:23:15.593'!
modelIndexFor: aCellIndex

	aCellIndex ifNil: [^ nil].

	^ (self rowOrder items: (self columnAt: aCellIndex x) items at: aCellIndex y)
		valueOfProperty: #modelIndex! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/16/2010 14:29:26.513'!
mouseDown: evt

	self selection
		add: (self cellIndexFromPoint: evt position)
		event: evt.
		
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. ! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 16:57:04.191'!
mouseEnter: evt

	evt hand newKeyboardFocus: self.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:49:23.957'!
mouseLeave: evt

	self hoveredCell: nil.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:49:27.815'!
mouseMove: evt

	self hoveredCell: (self cellIndexFromPoint: evt position).! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:06:02.419'!
onCurrentCellChanged

	self currentIndexChanged: self currentModelIndex.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:07:02.107'!
onSelectionChanged

	self selectionChanged: self selectedModelIndices.! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 10/14/2010 11:37:04.05'!
removeRow: aRowInfo

	aRowInfo items withIndexDo: [:item :index |
		(columns at: index) items remove: item].
	
	self removeAllMorphsIn: aRowInfo items.
	rows remove: aRowInfo.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/14/2010 11:40:59.344'!
removeRowFor: aParentModelIndex at: rowIndex

	self removeRow: (rows detect: [:row |
		row parentModelIndex = aParentModelIndex and: [row firstModelIndex row = rowIndex]])! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/14/2010 10:45:00.46'!
replaceMorphWith: aMorph atIndex: aModelIndex

	| oldMorph col row indent |
	oldMorph := (rows detect: [:rowInfo | rowInfo includes: aModelIndex]) itemAt: aModelIndex.
	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: (oldMorph valueOfProperty: #isExpanded).
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self rowFor: aModelIndex.
	row items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	col := self columnFor: aModelIndex.
	col items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	self
		removeMorph: oldMorph;
		addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		(col itemBefore: aMorph)
			ifNil: [indent := self indent] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent].
				"The item before is my sibling. Use its indentation."
				(item valueOfProperty: #modelIndex) parent = aModelIndex parent
					ifTrue: [indent := item valueOfProperty: #indent]]].
	aMorph setProperty: #indent toValue: indent.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/10/2010 13:02:41.787'!
resizedToWidth: newWidth height: newHeight

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:47.691'!
rowAt: index

	^ self rowOrder items: rows at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:07.12'!
rowBoundsFor: aRowIndex

	| row |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
		
	row := self rowAt: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 16:12:41.64'!
rowFor: aModelIndex

	^ rows detect: [:row | row includes: aModelIndex]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:50.256'!
rowOrder

	^ rowOrder! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:06:41.893'!
rowsDo: aBlock

	self rowOrder items: rows do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:49:38.102'!
rowsWithIndexDo: aBlock

	self rowOrder items: rows withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/20/2010 14:07:17.985'!
selectedModelIndices

	^ self selection cells collect: [:cellIndex |
		self modelIndexFor: cellIndex]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/10/2010 20:03:34.835'!
selection

	^ selection! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:43:53.154'!
selection: aSelection

	selection := aSelection.
	
	self connect: aSelection signal: #selectionChanged toSelector: #redrawLater.
	self connect: aSelection signal: #selectionChanged toSelector: #updateFocus.
	self connect: aSelection signal: #currentCellChanged toSelector: #redrawLater.
	self connect: aSelection signal: #selectionChanged toSelector: #onSelectionChanged.
	self connect: aSelection signal: #currentCellChanged toSelector: #onCurrentCellChanged.
	
	self redrawLater.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/14/2010 13:50:42.369'!
selectionBehavior

	^ selectionBehavior ifNil: [selectionBehavior := #selectCells]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:28:20.274'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"

	selectionBehavior := aSymbol.
	self redrawLater.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/20/2010 13:45:49.758'!
selectionChanged: someModelIndices

	self emit.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 14:30:17.153'!
selectionColor

	^ selectionColor ifNil: [selectionColor := Color r: 0.772 g: 0.858 b: 1.0]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/8/2010 14:37:57.041'!
selectionColor: aColor

	selectionColor := aColor.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:47.949'!
selectionMode

	^ selectionMode! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:07.606'!
selectionMode: aSelectionClass

	selectionMode := aSelectionClass.
	self selection: aSelectionClass new.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/10/2010 13:59:08.486'!
setHeaderItem: aMorph atColumn: anInteger

	(columns at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/12/2010 11:50:38.889'!
setHeaderItem: aMorph atRow: anInteger

	(rows at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 15:40:41.889'!
startDrag: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	[ | index ddm |
	
	(index := self modelIndexFor: (self cellIndexFromPoint: evt position))
		ifNil: [^ self].

	evt hand grabMorph: (TransferMorph withPassenger: index)]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:22.557'!
topForRow: aRowInfo

	| result |
	result := self top.
	self rowsDo: [:row |
		row = aRowInfo ifTrue: [^ result].
		result := result + row height].
	
	Error signal: 'Row info not found!!'.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:10.47'!
updateColumnsLayout

	| offset |
	self columnsDo: [:colInfo |
		offset := 0.
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex |
			| height |
			height := (rows at: rowIndex) height.
			colInfo vAlignment = #top
				ifTrue: [item top: offset].
			colInfo vAlignment = #center
				ifTrue: [item top: offset + (height - item height // 2)].
			colInfo vAlignment = #bottom
				ifTrue: [item bottom: offset + height].
							
			offset := offset + height]].! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 10/11/2010 18:07:00.708'!
updateExtent

	self extent:
		(columns
			ifEmpty: [0]
			ifNotEmpty: [(columns collect: [:col | col width]) sum])
		@
		(rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum])! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:00:37.584'!
updateFirstColumnIndent

	columns first items do: [:item |
		item left: item left + (item valueOfProperty: #indent)].! !

!UiItemViewport methodsFor: 'updating' stamp: 'mt 10/16/2010 08:23:31.568'!
updateFocus
	"The important part is always the current cell."
	
	self selection currentCell ifNotNil: [:cc |
		self focusChanged: (self cellBoundsFor: cc)].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:45:11.53'!
updateHeaderLayout
	"Relayout changed header items."
	
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		self columnsDo: [:colInfo | hh addMorphBack: colInfo headerItem]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		self rowsDo: [:rowInfo | vh addMorphBack: rowInfo headerItem]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:21.042'!
updateItemOrder

	"Sort after first column for now."
	self rowOrder updateWith: columns first items.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:03:45.47'!
updateLayout

	columns ifEmpty: [^ self].
	
	self
		updateSizesOfRowsAndColumns;
		updateItemOrder;
		updateColumnsLayout;
		updateRowsLayout;
		updateFirstColumnIndent;
		updateHeaderLayout;
		updateExtent.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:44:44.663'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		offset := 0.
		self columnOrder items: rowInfo items withIndexDo: [:item :colIndex |
			| width hAlignment |
			width := (columns at: colIndex) width.
			hAlignment := (columns at: colIndex) hAlignment.
			hAlignment = #left
				ifTrue: [item left: offset].
			hAlignment = #center
				ifTrue: [item left: offset + (width - item width // 2)].
			hAlignment = #right
				ifTrue: [item right: offset + width].
			
			offset := offset + width]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 08:11:00.988'!
updateSizesOfRowsAndColumns

	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:56.367'!
verticalHeader

	^ verticalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:50.126'!
verticalHeader: aMorph

	verticalHeader := aMorph.! !

UiItemViewport subclass: #UiListIconViewport
	instanceVariableNames: 'orientation maxItemExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiListIconViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/14/2010 17:21:49.457'!
cellBoundsFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super cellBoundsFor: aCellIndex].

	^ (((aCellIndex - (1@1)) * maxItemExtent) + self topLeft)
		extent: maxItemExtent! !

!UiListIconViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 10:14:26.148'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset cellIndex |
		offset := self topLeft.
		cellIndex := 1@0.
		self rowsDo: [:rowInfo | 
			cellIndex := cellIndex + (0@1).
			((offset extent: self width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > rows size])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > rows size])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListIconViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 17:21:08.76'!
drawSubmorphsOn: aCanvas 
	
	self orientation = #default
		ifTrue: [^ super drawSubmorphsOn: aCanvas].
		
	submorphs isEmpty ifTrue: [^self].	
	aCanvas
		clipBy: self clippingBounds
		during: [:canvas | submorphs reverseDo: [:m | canvas fullDrawMorph: m]]! !

!UiListIconViewport methodsFor: 'initialization' stamp: 'mt 10/14/2010 20:57:45.903'!
initialize

	super initialize.
	maxItemExtent := 1@1.
	self orientation: #default.! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:33:09.036'!
maxItemExtent

	^ maxItemExtent! !

!UiListIconViewport methodsFor: 'calculation' stamp: 'mt 10/14/2010 15:23:06.979'!
maxItemsPerLine

	self orientation = #vertical
		ifTrue: [^ self width // maxItemExtent x]
		ifFalse: [^ self height // maxItemExtent y]! !

!UiListIconViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 10:01:36.664'!
modelIndexFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [self rowAt: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [self rowAt: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) firstModelIndex! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:53:11.793'!
optimalSize

	columns ifEmpty: [^ 1@1].

	self orientation = #default ifTrue: [
		^ columns first optimalSize @ self height].
	
	self orientation = #vertical ifTrue: [
		^ maxItemExtent x @ self height].
	
	self orientation = #horizontal ifTrue: [
		^ self width @ maxItemExtent y].! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:21:19.074'!
orientation

	^ orientation! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:30:02.272'!
orientation: aSymbol
	"#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	aSymbol = orientation ifTrue: [^ self].
	orientation := aSymbol.
	
	orientation = #default
		ifTrue: [self selectionBehavior: #selectRows]
		ifFalse: [self selectionBehavior: #selectCells].! !

!UiListIconViewport methodsFor: 'geometry' stamp: 'mt 10/20/2010 14:53:43.833'!
updateExtent

	columns ifEmpty: [^ self].
	
	self orientation = #default ifTrue: [
		| newHeight optimalWidth |	
		newHeight := rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum].
	
		optimalWidth := columns first optimalSize.
	
		^ optimalWidth < self owner width
			ifTrue: [self extent: self owner width - 5 @ newHeight]
			ifFalse: [self extent: optimalWidth @ newHeight]].
		
	self extent: (((self submorphBounds extent / maxItemExtent) ceiling * maxItemExtent)
		max: (self owner extent - 5)).! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:25.756'!
updateLayout

	"There is no list wrapping in #default layout. Just use the super implementation."
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	self
		updateItemOrder;
		updateMaxItemExtent;
		updateSingleColumnLayout;
		updateExtent.! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:06:54.189'!
updateMaxItemExtent

	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:58.353'!
updateSingleColumnLayout

	| offset hAlignment |
	offset := self topLeft.
	hAlignment := columns first hAlignment.

	self rowOrder items: columns first items do: [:item |		
		hAlignment = #left
			ifTrue: [item topLeft: offset].
		hAlignment = #center
			ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
		hAlignment = #right
			ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

		self orientation = #vertical
			ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self owner width - 5)
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]]
			ifFalse: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self owner height - 5)
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].! !

UiItemViewport subclass: #UiTableViewport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 14:00:23.706'!
drawGridOn: aCanvas

	| offset |
	offset := self left.
	self columnsDo: [:colInfo | 
		offset := offset  + colInfo width.
		aCanvas
			line: offset @ self top
			to: offset @ self bottom
			color: (Color gray: 0.9)].
		
	offset := self top.
	self rowsDo: [:rowInfo | 
		offset := offset  + rowInfo height.
		aCanvas
			line: self left @ offset
			to: self right @ offset
			color: (Color gray: 0.9)].! !

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:57:07.344'!
drawOn: aCanvas

	self drawGridOn: aCanvas.
	super drawOn: aCanvas.! !

UiItemViewport subclass: #UiTreeViewport
	instanceVariableNames: 'indent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/17/2010 09:58:48.421'!
click: evt

	| cell item |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	item := (self rowAt: cell y) items at: 1.

	"Recognize a click on the decoration."
	(evt position x < item left
		and: [evt position x >= (item left - self indent)])
		ifTrue: [self decorationClicked: (item valueOfProperty: #modelIndex)].! !

!UiTreeViewport methodsFor: 'signals' stamp: 'mt 10/14/2010 13:13:30.709'!
decorationClicked: aModelIndex
	"Whenever the user clicks the expand/collapse decoration in front of an item."
	
	self emit.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:16:22.359'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	self drawTreeStructureOn: aCanvas.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/17/2010 09:54:46.812'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns ifEmpty: [^ self].
	
	(self leftForColumn: columns first) < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first ifNil: [first := 1@1].
	last ifNil: [last := 1@rows size].
	
	last < first ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| colIndex item cellBounds form |
		colIndex := self columnOrder unmapIndex: 1.
		cellBounds := self cellBoundsFor: colIndex@rowIndex.
		item := self columnOrder items: (self rowAt: rowIndex) items at: colIndex.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 13:14:25.565'!
indent

	^ indent ifNil: [indent := 12]! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/18/2010 19:09:04.846'!
initialize

	super initialize.
	
	rowOrder := UiTreeItemOrder new.
	
	self selectionBehavior: #selectRows.! !

Morph subclass: #UiLabel
	instanceVariableNames: 'form text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLabel commentStamp: 'mt 7/4/2010 08:53:31.639' prior: 0!
I am a descriptive widget that explains some content of another widget near me. I can show a form or a text.!

!UiLabel class methodsFor: 'testing' stamp: 'mt 6/29/2010 19:06:41.567'!
isWidgetClass

	^ true! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:53.936'!
widgetCategory
	
	^ 'Display Widgets'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:48.403'!
widgetClassIcon

	^ UiFugueIcons uiLabelIcon! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:24.431'!
widgetClassName

	^ 'Label'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/24/2010 11:12:57.562'!
widgetProperties

	^ {{'Custom'. #yourself} -> {
		#text -> String.
		#form -> Form}}! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:35:24.982'!
form

	^ form! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:36:48.648'!
form: aForm

	form := aForm.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'initialization' stamp: 'mt 7/4/2010 08:45:51.563'!
initialize

	super initialize.
	
	text := TextMorph new.
	text contents: 'Label'.
	text lock.
	
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		updateSubmorphs.! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:33:10.538'!
text

	^ text contents! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:44:15.376'!
text: aText

	text contents: aText asHtmlText.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'accessing - private' stamp: 'mt 7/4/2010 08:46:07.552'!
textMorph

	^ text! !

!UiLabel methodsFor: 'updating' stamp: 'mt 7/4/2010 08:39:47.448'!
updateSubmorphs

	(self submorphs notEmpty and: [self form isNil] and: [self submorphs first == text])
		ifTrue: [^ self].

	self	 removeAllMorphs.
	
	self form
		ifNil: [self addMorphBack: text]
		ifNotNil: [self addMorphBack: form asMorph].! !

Morph subclass: #UiRessourceMonitorDialog
	instanceVariableNames: 'view refreshButton gcButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiRessourceMonitorDialog class methodsFor: 'instance creation' stamp: 'mt 10/24/2010 12:30:21.819'!
open

	^ self new open! !

!UiRessourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 10/24/2010 19:50:24.318'!
initialize

	super initialize.
	refreshButton := UiPushButton new
		icon: UiFugueIcons arrowCircleDouble135Icon;
		text: 'Refresh'.
	gcButton := UiPushButton new
		icon: UiFugueIcons broomIcon;
		text: 'GC'.
	
	view := UiTableView new
		removeVerticalHeader;
		model: UiRessourceMonitorModel new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		setVAlignmentForColumn: 3 to: #center.
	
	self connect: refreshButton signal: #clicked: to: view selector: #reset.
	self connect: gcButton signal: #clicked: to: Smalltalk selector: #garbageCollect.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 3;
		cellInset: 5.
		
	self addMorphBack: view; addMorphBack: (SwaRowPanel for: {gcButton. SwaHFiller new. refreshButton}).! !

!UiRessourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 10/24/2010 12:29:56.994'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Ressource Monitor')
		extent: 350@300.
		
	self color: c.! !

Morph subclass: #UiWidgetPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiWidgetPage commentStamp: 'mt 7/14/2010 11:14:35.743' prior: 0!
I am used in a UiStackedWidget.!

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 13:14:14.223'!
widgetProperties

	^ {{'Stacked Widget - Layout'. #owner} -> {
		#topLeft -> Point.
		#width -> Integer.
		#height -> Integer.
		#hResizing -> #(rigid spaceFill shrinkWrap).
		#vResizing -> #(rigid spaceFill shrinkWrap)}.
		{'Stacked Widget - Pages'. #owner} -> {
			#currentIndex -> Integer}}! !

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 11:29:42.685'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing width height topLeft)! !

!UiWidgetPage methodsFor: 'initialization' stamp: 'mt 7/14/2010 10:32:53.703'!
initialize

	super initialize.
	self
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

Morph subclass: #UiWidgetPageButtonContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiWidgetPageButtonContainer commentStamp: 'mt 7/14/2010 11:15:56.239' prior: 0!
I am a container for edit buttons that has a high mouse priority to accept mouse clicks.!

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:09.338'!
handlerForMouseDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:21.162'!
handlerForYellowButtonDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'initialization' stamp: 'mt 7/16/2010 12:57:41.845'!
initialize

	super initialize.
	self
		color: (Color gray: 0.8);
		changeTableLayout;
		listDirection: #leftToRight;
		borderStyle: (BorderStyle raised width: 1);
		disableTableLayout: true;
		setToAdhereToEdge: #topRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/14/2010 11:20:22.466'!
mouseDownPriority

	^ 150! !

ScrollPane subclass: #UiAbstractItemView
	instanceVariableNames: 'itemDelegates verticalHeader horizontalHeader vHeaderScroller hHeaderScroller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiAbstractItemView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:18.144'!
widgetCategory
	
	^ 'Item Views (Model-Based)'! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 10/28/2010 10:08:25.008'!
widgetProperties

	^ {{'Item View'. #yourself} -> {
		#modelClass -> Object.
		#horizontalHeaderVisible -> Boolean.
		#verticalHeaderVisible -> Boolean}}! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 10/28/2010 10:02:41.999'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout')! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/19/2010 10:27:49.972'!
activated: aModelIndex
	"Single mouse click or pressing the return key."
	
	self emitAlways.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:12:01.1'!
addHorizontalHeader

	self addMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:36.704'!
addVerticalHeader

	self addMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 10/19/2010 10:53:56.83'!
autoSortBlock: aBlock

	self viewport rowOrder sortBlock: aBlock.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 10/14/2010 13:09:27.159'!
changeColumnsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	1 to: (self model rowCountFor: aParentModelIndex) do: [:row |
		start to: end do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport replaceMorphWith: item atIndex: index.
			item fadeIn]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 10/14/2010 13:09:37.343'!
changeRowsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport replaceMorphWith: item atIndex: index.
			item fadeIn]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/14/2010 20:26:04.229'!
clicked: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:55:45.797'!
currentIndexChanged: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/20/2010 14:08:00.82'!
currentModelIndex

	^ self viewport currentModelIndex! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/9/2010 10:54:44.107'!
defaultItemDelegate

	^ itemDelegates at: #default! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/14/2010 15:43:43.148'!
defaultItemDelegate: aDelegate

	itemDelegates at: #default put: aDelegate.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 10/18/2010 19:06:45.317'!
disableAutoSort

	self viewport rowOrder sortBlock: nil.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/14/2010 20:26:08.87'!
doubleClicked: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 10/18/2010 19:06:40.262'!
enableAutoSort

	self viewport rowOrder sortBlock: [:i1 :i2 |
		(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/11/2010 18:05:14.956'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: aModelIndex) do: [:row |
		1 to: (self model columnCountFor: aModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			aBoolean ifTrue: [item fadeIn]]].! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 10/10/2010 15:13:49.001'!
hLeftoverScrollRange

	scroller hasSubmorphs ifFalse:[^0].
	^ (self viewport width - scroller width + 5) max: 0! !

!UiAbstractItemView methodsFor: 'scrolling' stamp: 'mt 10/10/2010 13:46:48.63'!
hScrollBarValue: scrollValue

	super hScrollBarValue: scrollValue.
	hHeaderScroller offset: scroller offset x @ 0.! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:04:29.063'!
hasHorizontalHeader

	^ hHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:03:13.199'!
hasVerticalHeader

	^ vHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:07:05.122'!
horizontalHeaderVisible
		
	^ self hasHorizontalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:33.964'!
horizontalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addHorizontalHeader]
		ifFalse: [self removeHorizontalHeader].! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 10/21/2010 21:11:20.707'!
initialize

	"Initialize headers."
	verticalHeader := Morph new color: Color transparent; width: self scrollBarThickness; changeTableLayout; listDirection: #topToBottom.
	horizontalHeader := Morph new color: Color transparent; height: self scrollBarThickness; changeTableLayout; listDirection: #leftToRight.
	vHeaderScroller := TransformMorph new color: Color transparent.
	hHeaderScroller := TransformMorph new color: Color transparent.

	super initialize.
	
	self
		borderWidth: 0;
		color: Color white.
	
	"Initialize viewport."
	self scroller addMorph: self viewportClass new.
	self connect: self viewport signal: #focusChanged: toSelector: #scrollToShow:.
	self connect: self viewport signal: #clicked: toSelector: #clicked:.
	self connect: self viewport signal: #doubleClicked: toSelector: #doubleClicked:.
	self connect: self viewport signal: #selectionChanged: toSelector: #selectionChanged:.
	self connect: self viewport signal: #currentIndexChanged: toSelector: #currentIndexChanged:.
	self viewport verticalHeader: verticalHeader.
	self viewport horizontalHeader: horizontalHeader.
	
	"Initialize item delegates."
	itemDelegates := Dictionary new.
	self defaultItemDelegate: UiSimpleItemDelegate new.
	
	"Initialize headers - Finish."
	verticalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #height: pattern: #(2).
	vHeaderScroller addMorph: verticalHeader.

	horizontalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #width:.
	hHeaderScroller addMorph: horizontalHeader.! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 10/21/2010 21:09:55.396'!
initializeScrollBars
"initialize the receiver's scrollBar"

	(scrollBar := UiScrollBar new model: self slotName: 'vScrollBar')
			borderWidth: 1; 
			borderColor: Color black.
	(hScrollBar := UiScrollBar new model: self slotName: 'hScrollBar')
			borderWidth: 1; 
			borderColor: Color black.

	""
	scroller := TransformMorph new color: Color transparent.
	scroller offset: -3 @ 0.
	self addMorph: scroller.
	""
	scrollBar initializeEmbedded: retractableScrollBar not.
	hScrollBar initializeEmbedded: retractableScrollBar not.
	retractableScrollBar ifFalse: 
			[self 
				addMorph: scrollBar;
				addMorph: hScrollBar].

	Preferences alwaysShowVScrollbar ifTrue:
		[ self alwaysShowVScrollBar: true ].
		
	Preferences alwaysHideHScrollbar
		ifTrue:[self hideHScrollBarIndefinitely: true ]
		ifFalse:
			[Preferences alwaysShowHScrollbar ifTrue:
				[ self alwaysShowHScrollBar: true ]].
! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 10/14/2010 13:04:32.651'!
innerBounds

	| inner |
	inner := super innerBounds.
	
	self hasVerticalHeader ifTrue: [
		inner := inner insetBy: (verticalHeader width @ 0 corner: 0@0)].

	self hasHorizontalHeader ifTrue: [
		inner := inner insetBy: (0 @ horizontalHeader height corner: 0@0)].

	^ inner! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 10/14/2010 13:09:44.283'!
insertRowsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			item fadeIn]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/10/2010 10:34:00.872'!
itemDelegateFor: aModelIndex

	^ self defaultItemDelegate! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 10/14/2010 11:36:35.075'!
model: aModel

	self model ifNotNil: [:m | m disconnectAllSignals].
	
	super model: aModel.
	self reset.
	
	self model ifNotNil: [:m |
		self connect: m signal: #modelReset toSelector: #reset.
		self connect: m signal: #rowsInsertedFor:from:to: toSelector: #insertRowsFor:from:to:.
		self connect: m signal: #rowsChangedFor:from:to: toSelector: #changeRowsFor:from:to:.
		self connect: m signal: #rowsRemovedFor:from:to: toSelector: #removeRowsFor:from:to:.].! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/28/2010 10:04:51.755'!
modelClass

	^ self model
		ifNil: [nil]
		ifNotNil: [:m | m class]! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/28/2010 10:08:12.426'!
modelClass: aClass

	aClass
		ifNil: [self model: nil]
		ifNotNil: [:c | self model: c new].! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:54.15'!
removeHorizontalHeader

	self removeMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 10/14/2010 13:09:51.695'!
removeRowsFor: aParentModelIndex from: start to: end

	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		self viewport removeRowFor: aParentModelIndex at: row].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:43.32'!
removeVerticalHeader

	self removeMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/14/2010 21:02:31.888'!
reset
	self viewport clear.
	
	self fillViewportFor: nil animated: false.
	self resetHeaderItems.
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/14/2010 13:06:56.299'!
resetHeaderItems

	| index item |
	self model ifNil: [^ self].
	
	self hasVerticalHeader ifTrue: [
		1 to: (self model rowCountFor: nil) do: [:row |
			index := self model indexRow: row column: 0 parent: nil.
			item := (self itemDelegateFor: index) itemFor: index.
			verticalHeader width: (verticalHeader width max: item width).
			self viewport setHeaderItem: item atRow: row]].
	
	self hasHorizontalHeader ifTrue: [
		1 to: (self model columnCountFor: nil) do: [:col |
			index := self model indexRow: 0 column: col parent: nil.
			item := (self itemDelegateFor: index) itemFor: index.
			horizontalHeader height: (horizontalHeader height max: item height).
			self viewport setHeaderItem: item atColumn: col]].! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 10/10/2010 14:42:58.971'!
resizeScroller

	super resizeScroller.
	
	hHeaderScroller bounds: (scroller left @ self top
		extent: (scroller width @ horizontalHeader height)).
	vHeaderScroller bounds: (self left @ scroller top
		extent: (verticalHeader width @ scroller height)).! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 10/10/2010 13:11:49.345'!
scrollBarThickness
	"Includes border"

	^ Preferences scrollBarsNarrow
			ifTrue: [10]
			ifFalse: [14].! !

!UiAbstractItemView methodsFor: 'scrolling' stamp: 'mt 10/11/2010 17:35:05.273'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	|offset|
	offset := self scroller offset.
	
	(aRectangle right - offset x) > self innerBounds width
		ifTrue: [offset := (aRectangle left - self innerBounds width + aRectangle width min: self viewport width - self innerBounds width) @ offset y].
	(aRectangle left - offset x) < 0
		ifTrue: [offset := (aRectangle left min: self viewport width - self innerBounds width) @ offset y].
	
	
	(aRectangle top - offset y) < 0
		ifTrue: [offset := offset x @ (
					(aRectangle top min: self viewport height - self innerBounds height))].
	(aRectangle bottom - offset y) > self innerBounds height
		ifTrue: [offset := offset x @ (
					(aRectangle top - self innerBounds height + aRectangle height min: self viewport height - self innerBounds height))].
		
	offset = self scroller offset ifFalse: [
		self scroller offset: offset.
		self setScrollDeltas]! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/20/2010 14:07:37.965'!
selection

	^ self viewport selectedModelIndices! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:21:08.2'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"
	
	self viewport selectionBehavior: aSymbol.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:42:53.216'!
selectionChanged: someModelIndices

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:24:52.272'!
selectionColor: aColor

	self viewport selectionColor: aColor.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:26:27.009'!
selectionMode: aSelectionClass
	"Use can use all subclasses of UiViewSelection here."

	self viewport selectionMode: aSelectionClass.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 10/14/2010 19:16:51.554'!
setHAlignmentForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		hAlignment: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:06.532'!
setHeightForRow: anIndex to: anInteger

	| row |
	row := self viewport rowAt: anIndex.
	row resizeMode ~= #rigid
		ifTrue: [^ self].
		
	row height: anInteger.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:12.957'!
setResizeModeForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		resizeMode: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:24.149'!
setResizeModeForRow: anIndex to: aSymbol

	(self viewport rowAt: anIndex)
		resizeMode: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 10/14/2010 19:16:57.155'!
setVAlignmentForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		vAlignment: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:34.713'!
setWidthForColumn: anIndex to: anInteger

	| col |
	col := self viewport columnAt: anIndex.
	col resizeMode ~= #rigid
		ifTrue: [^ self].
		
	col width: anInteger.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'layouting' stamp: 'mt 10/14/2010 13:09:15.696'!
updateLayout

	self viewport updateLayout.
	self updateScrollBars.! !

!UiAbstractItemView methodsFor: 'scrolling' stamp: 'mt 10/10/2010 12:03:46.492'!
updateScrollBars

	self
		resizeScrollBars;
		resizeScroller;
		hideOrShowScrollBars;
		hSetScrollDelta;
		vSetScrollDelta.! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 10/10/2010 15:10:56.555'!
vLeftoverScrollRange

	scroller hasSubmorphs ifFalse:[^0].
	^ (self viewport height - scroller height + 5) max: 0! !

!UiAbstractItemView methodsFor: 'scrolling' stamp: 'mt 10/10/2010 13:46:57.085'!
vScrollBarValue: scrollValue

	super vScrollBarValue: scrollValue.
	vHeaderScroller offset: 0 @ scroller offset y.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:51.888'!
verticalHeaderVisible

	^ self hasVerticalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:21.13'!
verticalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addVerticalHeader]
		ifFalse: [self removeVerticalHeader].! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 14:20:02.069'!
viewport
	"Return the morph that is scrolled."
	
	^ self scroller submorphs
		ifEmpty: [nil]
		ifNotEmpty: [self scroller submorphs first]! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 12:08:54.27'!
viewportClass

	self subclassResponsibility.! !

UiAbstractItemView subclass: #UiListIconView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiListIconView commentStamp: 'mt 10/20/2010 14:02:59.798' prior: 0!
I am a list view that is able to break the line of items in one direction and shows as many items as possible.

I map some signals to ones that only indicate row indices, e.g., selected row indices instead of whole model indices.!

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:39.613'!
isWidgetClass

	^ true! !

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:03:20.427'!
widgetClassIcon

	^ UiFugueIcons uiListBoxIcon! !

!UiListIconView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:46.933'!
widgetClassName

	^ 'List View'! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:45:12.941'!
currentRow

	^ self currentModelIndex ifNotNil: [:cmi | cmi row]! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:10:14.822'!
currentRow: anIndex

	anIndex ifNil: [^ self viewport selection currentCell: nil].
	self viewport selection currentCell: (1@anIndex).! !

!UiListIconView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:53:08.525'!
currentRowChanged: newRowIndex

	self emit.! !

!UiListIconView methodsFor: 'geometry' stamp: 'mt 10/14/2010 17:27:16.269'!
extent: aPoint

	super extent: aPoint.
	
	self viewport ifNotNil: [:v |
		v orientation = #default
			ifTrue: [v updateExtent]
			ifFalse: [v updateLayout]].! !

!UiListIconView methodsFor: 'model access' stamp: 'mt 10/14/2010 17:28:02.87'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: nil) do: [:row |
		index := self model indexRow: row column: 1 parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		self viewport addMorph: item atIndex: index.
		aBoolean ifTrue: [item fadeIn]].! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:09.581'!
hAlignment: aSymbol

	self setHAlignmentForColumn: 1 to: aSymbol.! !

!UiListIconView methodsFor: 'initialization' stamp: 'mt 10/20/2010 14:02:19.337'!
initialize

	super initialize.
	
	self connect: self viewport signal: #currentIndexChanged: toSelector: #onCurrentIndexChanged:.
	self connect: self viewport signal: #selectionChanged: toSelector: #onSelectionChanged:.! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 15:27:12.646'!
listOrientation

	^ self viewport orientation! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 18:37:15.275'!
listOrientation: aSymbol
	"#default ... no breaks, horzintal scrolling if needed, full row selection
	#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	self listOrientation = aSymbol
		ifTrue: [^ self].
	
	self viewport orientation: aSymbol.
	self updateLayout.! !

!UiListIconView methodsFor: 'updating' stamp: 'mt 10/20/2010 14:44:47.163'!
onCurrentIndexChanged: aModelIndex
	"Map to the row index. Ignore the column in a list."
	
	self currentRowChanged: (aModelIndex ifNotNil: [:m | m row]).! !

!UiListIconView methodsFor: 'updating' stamp: 'mt 10/20/2010 14:01:11.915'!
onSelectionChanged: someModelIndices

	self selectedRowsChanged: (someModelIndices collect: [:i | i row]).! !

!UiListIconView methodsFor: 'signals' stamp: 'mt 10/20/2010 14:00:30.024'!
selectedRowsChanged: someRowIndices

	self emit.! !

!UiListIconView methodsFor: 'geometry' stamp: 'mt 10/26/2010 20:34:36.163'!
useOptimalSize
	"Change the size of the view that only one kind/direction of scrolling is needed."

	self listOrientation = #default ifTrue: [
		self height: self viewport optimalSize y + 8.
		self width: self viewport optimalSize x + self scrollBarThickness + 5 +
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].
		
	self listOrientation = #vertical ifTrue: [
		self height: self viewport optimalSize y + 8.
		self width: self viewport optimalSize x + self scrollBarThickness + 5 +
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].

	self listOrientation = #horizontal ifTrue: [
		self width: self viewport optimalSize x + 8.
		self height: self viewport optimalSize y + self scrollBarThickness +
			(self hasHorizontalHeader ifTrue: [horizontalHeader width] ifFalse: [0])].! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:17.877'!
vAlignment: aSymbol

	self setVAlignmentForColumn: 1 to: aSymbol.! !

!UiListIconView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 14:31:08.457'!
viewportClass

	^ UiListIconViewport! !

UiListIconView subclass: #UiListWidget
	instanceVariableNames: 'currentRow items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiListWidget commentStamp: 'mt 10/19/2010 19:32:52.216' prior: 0!
Simple list. Item based. No model required.!

!UiListWidget class methodsFor: 'instance creation' stamp: 'mt 10/19/2010 19:38:28.314'!
new

	^ super new
		model: UiListWidgetModel new! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:00.509'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:54:17.534'!
widgetClassIcon

	^ UiFugueIcons uiListBoxBlueIcon! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:21:46.085'!
widgetClassName

	^ 'List Widget'! !

!UiListWidget class methodsFor: 'properties' stamp: 'mt 10/28/2010 10:08:58.312'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(modelClass)! !

!UiListWidget methodsFor: 'adding' stamp: 'mt 10/19/2010 20:03:04.117'!
addIcon: anIcon text: aLabel

	self model addItem: (UiListWidgetItem new text: aLabel; icon: anIcon).! !

!UiListWidget methodsFor: 'adding' stamp: 'mt 10/19/2010 20:02:59.691'!
addText: aLabel

	self model addItem: (UiListWidgetItem new text: aLabel).! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:41:33.614'!
clear

	self model: UiListWidgetModel new.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:15:08.334'!
currentIcon

	^ self currentItem ifNotNil: [:i | i icon]! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 10:30:03.07'!
currentItem

	^ self currentRow ifNotNil: [:cc | self items at: cc]! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:14:43.107'!
currentText

	^ self currentItem ifNotNil: [:i | i text]! !

!UiListWidget methodsFor: 'signals' stamp: 'mt 6/29/2010 09:53:38.414'!
currentTextChanged: aLabel

	self emit.! !

!UiListWidget methodsFor: 'initialization' stamp: 'mt 10/20/2010 13:50:29.946'!
initialize
	
	super initialize.
	self connect: self viewport signal: #activated: toSelector: #onActivated:.! !

!UiListWidget methodsFor: 'signals' stamp: 'mt 10/20/2010 10:35:08.772'!
itemActivated: aListWidgetItem

	self emit.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:40:25.443'!
items

	^ self model items! !

!UiListWidget methodsFor: 'updating' stamp: 'mt 10/20/2010 14:40:03.899'!
onActivated: aModelIndex

	self itemActivated: (aModelIndex
		ifNotNil: [self items at: aModelIndex row]).! !

!UiListWidget methodsFor: 'updating' stamp: 'mt 10/20/2010 14:46:04.736'!
onCurrentIndexChanged: aModelIndex

	super onCurrentIndexChanged: aModelIndex.
	self currentTextChanged: (aModelIndex ifNotNil: [:m | (self items at: m row) text]).! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:43.237'!
size

	^ self items size! !

UiAbstractItemView subclass: #UiTableView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTableView commentStamp: 'mt 10/19/2010 10:51:11.46' prior: 0!
I have a vertical header by default and are used for table-like models.!

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:43.968'!
isWidgetClass

	^ true! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:07:06.235'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:09.963'!
widgetClassName

	^ 'Table View'! !

!UiTableView methodsFor: 'initialization' stamp: 'mt 10/14/2010 12:12:23.38'!
initialize

	super initialize.
		
	self
		addMorph: vHeaderScroller;
		addMorph: hHeaderScroller.
	
	self resizeScroller.! !

!UiTableView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:57:19.079'!
viewportClass

	^ UiTableViewport! !

UiAbstractItemView subclass: #UiTreeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTreeView commentStamp: 'mt 10/19/2010 10:51:34.42' prior: 0!
I am a view that supports tree-like models and a tree in the first column.!

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:46.249'!
isWidgetClass

	^ true! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:04:01.037'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTreeIcon! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:03.461'!
widgetClassName

	^ 'Tree View'! !

!UiTreeView methodsFor: 'initialization' stamp: 'mt 10/14/2010 12:11:00.927'!
initialize

	super initialize.
	
	self connect: self viewport signal: #doubleClicked: toSelector: #toggleIndex:.
	self connect: self viewport signal: #decorationClicked: toSelector: #toggleIndex:.
	
	self
		"addMorph: vHeaderScroller;"
		addMorph: hHeaderScroller.
	
	self resizeScroller.! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 10/14/2010 13:10:43.16'!
toggleIndex: aModelIndex

	| row |
	
	row := self viewport rowFor: aModelIndex.
	
	row isExpanded
		ifTrue: [
			row items first setProperty: #isExpanded toValue: false.
			self viewport collapseRow: row]
		ifFalse: [
			row items first setProperty: #isExpanded toValue: true.
			self
				fillViewportFor: row firstModelIndex
				animated: true].
	
	self updateLayout.! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 10/19/2010 14:40:36.647'!
toggleTopLevelRow: aRowIndex

	self toggleIndex: ((UiSimpleModelIndex row: aRowIndex column: 1) model: self model).! !

!UiTreeView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:21:16.162'!
viewportClass

	^ UiTreeViewport! !

Point subclass: #UiModelIndex
	instanceVariableNames: 'parent model properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiModelIndex commentStamp: 'mt 10/16/2010 08:08:55.091' prior: 0!
Abstract class that represents a wrapper around some data item from a model in a view, i.e., tree view, table view, list view. Concrete implementations need to define which messages will be understood by the model in order to get the data.

No data caching intended here. But may store useful properties in order to be able to navigate quickly in the model whenever confronted with that model index again, e.g. "Please, model, tell be all your child indices based on this parent index."

A model generates all model indices.!

!UiModelIndex class methodsFor: 'instance creation' stamp: 'mt 10/9/2010 16:37:33.666'!
row: aRow column: aColumn

	^ (self
		x: aColumn
		y: aRow) initialize! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 10/9/2010 19:57:29.693'!
= anotherModelIndex

	^ super = anotherModelIndex
		and: [self parent = anotherModelIndex parent]! !

!UiModelIndex methodsFor: 'accessing - point' stamp: 'mt 10/7/2010 18:41:30.667'!
column

	^ self x! !

!UiModelIndex methodsFor: 'dragging' stamp: 'mt 10/19/2010 15:23:07.236'!
dragLabel

	^ self text asString! !

!UiModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/8/2010 13:58:59.151'!
hasChildren

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 10/13/2010 15:07:28.4'!
hash

	^ super hash bitXor: self parent hash! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:33:40.351'!
icon

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:52:00.933'!
includesProperty: aSymbol 

	^ properties includesKey: aSymbol! !

!UiModelIndex methodsFor: 'initialization' stamp: 'mt 10/9/2010 16:36:13.61'!
initialize

	super initialize.
	properties := Dictionary new.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:33.729'!
model

	^ model! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:45.407'!
model: aModel

	model := aModel.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:15.322'!
parent
	"Return parent model index."
	
	^ parent! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:27.971'!
parent: aModelIndex
	
	parent := aModelIndex.! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:38.613'!
removeProperty: aSymbol 

	properties ifNil: [^ self].
	properties removeKey: aSymbol ifAbsent: [].! !

!UiModelIndex methodsFor: 'accessing - point' stamp: 'mt 10/7/2010 18:41:24.938'!
row

	^ self y! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:10.368'!
setProperty: aSymbol toValue: anObject 

	anObject ifNil: [^ self removeProperty: aSymbol].
	properties at: aSymbol put: anObject.! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:30:00.274'!
text

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:49.248'!
valueOfProperty: aSymbol 

	^ self
		valueOfProperty: aSymbol
		ifAbsent: []! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:38:51.641'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ properties
		at: aSymbol
		ifAbsent: aBlock! !

UiModelIndex subclass: #UiPluggableModelIndex
	instanceVariableNames: 'textSelector iconSelector hasChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiPluggableModelIndex commentStamp: 'mt 10/16/2010 08:04:49.988' prior: 0!
Customizable model index that may use any selector of a model that is appropriate to get #hasChildren, #text, or #icon.!

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/16/2010 08:03:47.754'!
hasChildren

	^ model perform: hasChildrenSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:12.752'!
hasChildrenSelector

	^ hasChildrenSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:04.084'!
hasChildrenSelector: aSymbol

	hasChildrenSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/8/2010 10:02:19.278'!
icon

	^ model perform: iconSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:58:07.041'!
iconSelector

	^ iconSelector ! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:58:14.566'!
iconSelector: aSymbol

	iconSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/8/2010 10:02:11.707'!
text

	^ model perform: textSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:31:08.265'!
textSelector

	^ textSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:31:00.834'!
textSelector: aSymbol

	textSelector := aSymbol.! !

UiModelIndex subclass: #UiSimpleModelIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiSimpleModelIndex commentStamp: 'mt 10/16/2010 08:05:34.628' prior: 0!
Simple implementation of a model index that assumes that the model understands some default messages as #textFor:, #iconFor:, and #hasChildrenFor:.!

!UiSimpleModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/10/2010 11:35:51.993'!
hasChildren

	^ model hasChildrenFor: self! !

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:58:55.129'!
icon

	^ model iconFor: self! !

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:32:11.105'!
text

	^ model textFor: self! !

BorderedMorph subclass: #UiContainer
	instanceVariableNames: 'editMode focusRectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiContainer commentStamp: 'mt 7/13/2010 09:34:37.877' prior: 0!
I am a, normally invisible, container or owner morph for various UI elements. If I am in #editMode, I support drag&drop operations.!

UiContainer subclass: #UiButtonGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButtonGroup commentStamp: 'mt 7/13/2010 09:32:47.81' prior: 0!
I am a container for buttons that make my submorphs/buttons auto-exclusive.!

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:52:38.557'!
widgetClassIcon

	^ UiFugueIcons uiGroupBoxIcon! !

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:07:04.687'!
widgetClassName

	^ 'Button Group'! !

!UiButtonGroup methodsFor: 'submorphs-add/remove' stamp: 'mt 7/1/2010 08:23:06.023'!
addMorphBack: aButton

	super addMorphBack: aButton.
	
	aButton autoExclusive: true.
	
	self
		connect: aButton signal: #clicked: toSelector: #clickButton: pattern: #(0);
		connect: aButton signal: #pressed toSelector: #pressButton: pattern: #(0);
		connect: aButton signal: #released toSelector: #releaseButton: pattern: #(0).! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:16:04.263'!
button: anId

	 self submorphs withIndexDo: [:m :i | i = anId ifTrue: [^ m]].
	
	^ nil! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:14.563'!
buttonClicked: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:30.004'!
buttonPressed: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:48.494'!
buttonReleased: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:28.017'!
checkedButton

	^ self submorphs detect: [:m | m isChecked] ifNone: [nil]! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:20.631'!
checkedId

	self submorphs withIndexDo: [:m :i | m isChecked ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:32.662'!
clickButton: aButton

	self buttonClicked: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:14:12.383'!
id: aButton

	self submorphs withIndexDo: [:m :i | m == aButton ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:44.088'!
pressButton: aButton

	self buttonPressed: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:54.688'!
releaseButton: aButton

	self buttonReleased: aButton id: (self id: aButton).! !

!UiButtonGroup methodsFor: 'dropping/grabbing' stamp: 'mt 10/22/2010 12:50:11.311'!
wantsDroppedMorph: aMorph event: evt

	(((aMorph isKindOf: TransferMorph)
		and: [UiButton subclasses includes: (aMorph passenger model widgetAt: aMorph passenger)])
		or: [aMorph isKindOf: UiButton])
		ifTrue: [^ super wantsDroppedMorph: aMorph event: evt].
	
	^ false! !

!UiContainer class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:36:20.651'!
isWidgetClass

	^ true! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:45:30.19'!
widgetCategory
	
	^ 'Containers & Spacer'! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:47.132'!
widgetClassIcon

	^ UiFugueIcons uiPanelIcon! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:49.177'!
widgetClassName

	^ 'Widget Container'! !

!UiContainer class methodsFor: 'properties' stamp: 'mt 10/28/2010 11:13:26.765'!
widgetProperties

	^ {{'Container'. #yourself} -> {
		#color -> Object}}! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 10/28/2010 10:41:28.447'!
acceptDroppingMorph: aMorph event: evt

	| result |
	(aMorph isKindOf: TransferMorph)
		ifTrue: [ (aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].

			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget.
				
			^ self]].

	result := super acceptDroppingMorph: aMorph event: evt.
	
	self
		changeFocusTo: aMorph bounds;
		changeSelectionTo: aMorph.
	
	^ result! !

!UiContainer methodsFor: 'focus' stamp: 'mt 10/23/2010 09:50:30.956'!
changeFocusTo: aRectangle

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self owner changeFocusTo: aRectangle].
	
	aRectangle = self bounds
		ifTrue: [focusRectangle := nil].
	
	focusRectangle := aRectangle ifNotNil: [:r | r outsetBy: (2@2)].
	self redrawLater.! !

!UiContainer methodsFor: 'selection' stamp: 'mt 10/26/2010 20:22:58.571'!
changeSelectionTo: aMorph
	"Talk to root container."

	(self owner isKindOf: UiContainer)
		ifTrue: [self owner changeSelectionTo: aMorph]
		ifFalse: [	self selectionChanged: aMorph].
			
	(aMorph owner isKindOf: UiContainer)
		ifTrue: [aMorph addHalo].! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:07:59.575'!
click: evt

"	| clickedMorph |
	clickedMorph := self submorphs detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	evt yellowButtonPressed ifTrue: [
		self showContextMenuForMorph: clickedMorph atHand: evt hand]."
	
	| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		
	self
		changeFocusTo: clickedMorph bounds;
		changeSelectionTo: clickedMorph.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/27/2010 13:43:16.726'!
doubleClick: evt! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/26/2010 20:20:20.839'!
drawFocusOn: aCanvas rectangle: aRect
	
"	aCanvas
		frameRectangle: (aRect insetBy: 1)
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.8) muchDarker.
		
	aCanvas
		frameRoundRect: aRect
		radius: 3
		width: 1
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.5) muchDarker."! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/28/2010 11:08:59.269'!
drawOn: aCanvas

	self editMode
		ifFalse: [^ super drawOn: aCanvas].
	
	aCanvas
		fillRectangle: self bounds
		fillStyle: ((self color = Color transparent)
			ifTrue: [SolidFillStyle color: ((Color gray: 0.3) alpha: 0.1)]
			ifFalse: [self fillStyle])
		borderStyle: self borderStyle.

	focusRectangle ifNotNil: [self drawFocusOn: aCanvas rectangle: focusRectangle].! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:17:26.068'!
editMode

	^ editMode ifNil: [editMode := false]! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 11:07:21.218'!
editMode: aBoolean

	editMode := aBoolean.
	
	self dropEnabled: editMode.
	self dragEnabled: editMode.
	
	self submorphs
		select: [:m | m isKindOf: UiContainer]
		thenDo: [:m | m editMode: aBoolean].! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/28/2010 11:03:51.082'!
focusChanged: aBoolean

	self emit.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 09:18:46.354'!
handlesMouseDown: evt

	^ self editMode! !

!UiContainer methodsFor: 'initialization' stamp: 'mt 10/26/2010 20:01:29.289'!
initialize

	super initialize.
	self
		extent: 100@100;
		color: Color transparent;
		borderWidth: 0;
		cellInset: 4;
		layoutInset: 4.! !

!UiContainer methodsFor: 'testing' stamp: 'mt 10/27/2010 20:39:00.491'!
isUiContainer

	^ true! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/28/2010 11:03:39.618'!
keyboardFocusChange: aBoolean

	self focusChanged: aBoolean.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:06:01.973'!
mouseDown: evt

	"| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	self changeSelectionTo: clickedMorph."

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. nil. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	"self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater]."! !

!UiContainer methodsFor: 'events-processing' stamp: 'mt 6/30/2010 09:18:26.354'!
mouseDownPriority
	"Give me ALL events."
	
	self editMode ifFalse: [^ super mouseDownPriority].
	^ 100! !

!UiContainer methodsFor: 'geometry' stamp: 'mt 7/1/2010 17:54:17.265'!
outerBounds

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self bounds outsetBy: (3@3 corner: 3@3)]
		ifFalse: [^ self bounds].! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/30/2010 09:29:37.854'!
selectionChanged: aMorph

	self emit.! !

!UiContainer methodsFor: 'context menu' stamp: 'mt 6/28/2010 11:13:33.993'!
showContextMenuForMorph: aMorph atHand: aHand

	| menu |
	menu := SBMenu new.
	
	self
		connect: (menu addAction: (SBAction new text: 'vResizing'))
		signal: #triggered
		to: aMorph
		selector: #vResizing:
		pattern: #(=#spaceFill).
	
	"Clean up the menu."
	menu connect: self signal: #focusChanged: toSelector: #delete.
	
	"Get focus and show menu."
	aHand newKeyboardFocus: self.
	menu popUp..! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:08:08.144'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
	
	self changeFocusTo: nil.
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 6/28/2010 16:46:21.331'!
wantsDroppedMorph: aMorph event: evt

	self redrawLater.
	^ super wantsDroppedMorph: aMorph event: evt! !

UiContainer subclass: #UiSpacer
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:44:49.988'!
widgetClassIcon

	^ UiFugueIcons uiAccordionIcon! !

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:43:44.923'!
widgetClassName

	^ 'Spacer'! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/26/2010 20:07:37.101'!
widgetProperties

	^ super widgetProperties, {{'Spacer'. #yourself} -> {
		#orientation -> #(horizontal vertical)}}! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/27/2010 09:42:04.578'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing 'TableLayout' 'ProportionalLayout')! !

!UiSpacer methodsFor: 'drawing' stamp: 'mt 10/28/2010 10:58:19.197'!
drawOn: aCanvas

	self editMode ifFalse: [^ self].
	
	self orientation = #horizontal ifTrue: [
		aCanvas
			line: self topLeft to: self bottomLeft color: self color;
			line: self topRight to: self bottomRight color: self color;
			line: self topLeft + (0@(self height // 2)) to: self topRight + (0@(self height // 2)) color: self color].
		
	self orientation = #vertical ifTrue: [
		aCanvas
			line: self topLeft to: self topRight color: self color;
			line: self bottomLeft to: self bottomRight color: self color;
			line: self topLeft + ((self width // 2) @ 0) to: self bottomLeft + ((self width // 2) @ 0) color: self color].! !

!UiSpacer methodsFor: 'initialization' stamp: 'mt 10/26/2010 20:36:06.836'!
initialize

	super initialize.
	self
		color: Color blue;
		orientation: #horizontal.! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:59.594'!
orientation

	^ orientation! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:51.389'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation == aSymbol
		ifTrue: [^ self].
		
	orientation := aSymbol.
	self updateLayout.! !

!UiSpacer methodsFor: 'geometry' stamp: 'mt 10/26/2010 20:04:04.927'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 1@1)! !

!UiSpacer methodsFor: 'updating' stamp: 'mt 10/26/2010 20:37:43.15'!
updateLayout

	self orientation = #horizontal
		ifTrue: [self
			hResizing: #spaceFill;
			vResizing: #rigid].
		
	self orientation = #vertical
		ifTrue: [self
			hResizing: #rigid;
			vResizing: #spaceFill].
		
	self redrawLater.! !

!UiSpacer methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:37:26.982'!
wantsDroppedMorph: aMorph event: evt

	^ false! !

UiContainer subclass: #UiStackedWidget
	instanceVariableNames: 'pages nextPageButton previousPageButton addPageButton removePageButton currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:08.176'!
widgetClassIcon

	^ UiFugueIcons uiLayeredPaneIcon! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:05:23.132'!
widgetClassName

	^ 'Stacked Widget'! !

!UiStackedWidget methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:40:20.732'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [(aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self currentPage addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].
				
			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget]]
		ifFalse: [
			self currentPage addMorphBack: aMorph.
			
			self
				changeFocusTo: aMorph bounds;
				changeSelectionTo: aMorph].
		
	"self updateCurrentPage."! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/14/2010 10:40:49.279'!
addPage

	self pages add: UiWidgetPage new.
	self currentIndex: self pages size.! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:03:25.639'!
click: evt

	| clickedMorph |
	clickedMorph := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	clickedMorph == self
		ifTrue: [self
			changeFocusTo: self currentPage bounds;
			changeSelectionTo: self currentPage]
		ifFalse: [self
			changeFocusTo: clickedMorph bounds;
			changeSelectionTo: clickedMorph].! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:54:24.59'!
currentIndex

	^ currentIndex! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:00:45.703'!
currentIndex: anInteger

	(anInteger = currentIndex
		or: [anInteger < 1]
		or: [anInteger > self pages size]) ifTrue: [^ self].
	
	currentIndex := anInteger.
	
	self updateCurrentPage.! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:19:46.577'!
currentPage

	^ self pages at: self currentIndex.! !

!UiStackedWidget methodsFor: 'initialization' stamp: 'mt 7/16/2010 13:12:51.61'!
initialize

	| buttonContainer |
	super initialize.
	
	nextPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow000SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Next Page'.

	self connect: nextPageButton signal: #clicked: toSelector: #nextPage.
		
	previousPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow180SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Previous Page'.
	
	self connect: previousPageButton signal: #clicked: toSelector: #previousPage.

	addPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons plusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Add Page'.

	self connect: addPageButton signal: #clicked: toSelector: #addPage.

	removePageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons minusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Remove Page'.

	self connect: removePageButton signal: #clicked: toSelector: #removeCurrentPage.
	
	buttonContainer := UiWidgetPageButtonContainer new.
	
	buttonContainer
		addMorphBack: addPageButton;
		addMorphBack: removePageButton;
		addMorphBack: previousPageButton;
		addMorphBack: nextPageButton.
	
	self changeTableLayout.
	self addMorphBack: buttonContainer.
	self addPage. "First empty page."! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:15:59.084'!
nextPage

	self currentIndex: (self currentIndex + 1 min: self pages size).! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:36:45.708'!
pages

	^ pages ifNil: [pages := OrderedCollection new]! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:16:13.279'!
previousPage

	self currentIndex: (self currentIndex - 1 max: 1).! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/16/2010 13:13:05.39'!
removeCurrentPage

! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 7/13/2010 10:09:25.305'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiStackedWidget methodsFor: 'updating' stamp: 'mt 10/23/2010 09:39:13.865'!
updateCurrentPage

	| buttonContainer |
	buttonContainer := nextPageButton owner.
	
	self
		removeAllMorphs;
		addMorphBack: self currentPage;
		addMorphFront: buttonContainer;
		changeFocusTo: self currentPage bounds;
		changeSelectionTo: self currentPage.! !

PluggableTextMorph subclass: #UiTextEdit
	instanceVariableNames: 'text validator outerBorderWidth autoConvert'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

UiTextEdit subclass: #UiLineEdit
	instanceVariableNames: 'helpText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:55:02.739'!
widgetClassIcon

	^ UiFugueIcons uiTextFieldIcon! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:05.575'!
widgetClassName

	^ 'Line Edit'! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/28/2010 09:38:59.208'!
widgetProperties

	^ super widgetProperties, {{'Line Edit'. #yourself} -> {
		#helpText -> String}}! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/27/2010 09:46:54.189'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(vResizing)! !

!UiLineEdit methodsFor: 'drawing' stamp: 'mt 10/27/2010 13:59:31.849'!
drawHelpTextOn: aCanvas

	| font |
	(self helpText isEmpty or: [self textMorph contents notEmpty]) ifTrue: [^ self].

	font := self textMorph textStyle defaultFont.

	aCanvas
		drawString: self helpText 
		in: ((self topLeft extent: self width @ font height) translateBy: 5 @ (self height - font height // 2))
		font: font
		color: (Color gray: 0.7).! !

!UiLineEdit methodsFor: 'drawing' stamp: 'mt 9/18/2010 15:51:20.667'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawHelpTextOn: aCanvas.! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:47:25.286'!
helpText

	^ helpText ifNil: [helpText := '']! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:52:27.508'!
helpText: aString
	"Drawn whenver #theText is empty."
	
	helpText := aString.
	self redrawLater.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:04:47.018'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		setProperty: #noVScrollBarPlease toValue: true;
		height: 20.
	
	"Fix initial state."
	self
		setText: 'LineEdit';
		resizeScroller.
	
	self textMorph
		wrapFlag: false;
		acceptOnCR: true.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:08:53.286'!
textMorphClass

	^ UiLineEditTextMorph! !

!UiLineEdit methodsFor: 'updating' stamp: 'mt 9/13/2010 11:14:16.838'!
update: aSymbol

	aSymbol == #appendEntry
		ifTrue: [^ self].
		
	super update: aSymbol.! !

!UiTextEdit class methodsFor: 'testing' stamp: 'mt 9/13/2010 10:59:48.079'!
isWidgetClass

	^ true! !

!UiTextEdit class methodsFor: 'instance creation' stamp: 'mt 9/13/2010 10:59:48.163'!
new

	| instance |
	instance := super new.
	
	instance
		on: instance
		text: #theText
		accept: #theText:
		readSelection: nil
		menu: nil.
	
	^ instance! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:19.428'!
widgetCategory

	^ 'Input Widgets'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:54:49.935'!
widgetClassIcon

	^ UiFugueIcons uiTextAreaIcon! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 9/13/2010 11:00:16.518'!
widgetClassName

	^ 'Text Edit'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/28/2010 10:25:52.022'!
widgetProperties

	^ {{'Text Edit'. #yourself} -> {
		#theText -> String.
		#readOnly -> Boolean.
		#outerBorderWidth -> Integer.
		#autoConvert -> Boolean.
		#autoAccept -> Boolean}}! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/27/2010 09:46:35.599'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout')! !

!UiTextEdit methodsFor: 'model access' stamp: 'mt 9/13/2010 10:59:46.025'!
acceptTextInModel
	"Overridden to ensure String - not Text."
	
	| valueToAccept |
	valueToAccept := self convertedValue.
	
	model perform: setTextSelector with: valueToAccept.
	
	^ true! !

!UiTextEdit methodsFor: 'editing' stamp: 'mt 9/13/2010 10:59:46.129'!
autoAccept

	^ self textMorph autoAccept! !

!UiTextEdit methodsFor: 'editing' stamp: 'mt 9/13/2010 10:59:46.191'!
autoAccept: aBoolean

	self textMorph autoAccept: aBoolean! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/27/2010 14:07:46.106'!
autoConvert

	^ autoConvert ifNil: [autoConvert := false]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/27/2010 14:08:08.635'!
autoConvert: aBoolean
	"If enabled, converts the text after each keystroke."
	
	autoConvert := aBoolean.! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 10/27/2010 14:08:41.779'!
convertText

	self autoConvert ifFalse: [^ self].
	textMorph contents: self convertedText.! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 9/13/2010 10:59:46.333'!
convertedText

	^ self convertedValue asString! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 9/13/2010 10:59:46.43'!
convertedValue

	^ self validator value: textMorph text asString! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 9/18/2010 15:45:04.051'!
drawBorderOn: aCanvas

	self outerBorderWidth = 0 ifTrue: [^ self].
	
	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: self outerBorderWidth
		color: (Color gray: 0.3).! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 9/13/2010 10:59:46.602'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawBorderOn: aCanvas.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 14:10:29.168'!
editingFinished: text
	"Emitted whenever focus changes or return key pressed."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'macpal' stamp: 'mt 9/13/2010 10:59:46.796'!
flash

	"No flash."! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 9/13/2010 10:59:46.666'!
fullDrawOn: aCanvas
	"Skip adornments."
	
	^ self perform: #fullDrawOn: withArguments: {aCanvas} inSuperclass: ScrollPane.! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 14:17:05.517'!
initialize

	super initialize.
	
	self
		setProperty: #noHScrollBarPlease toValue: true;
		setProperty: #vScrollBarAlways toValue: false;
		width: 150;
		height: 100;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1).
	
	"Fix initial state."
	self
		setText: 'Please enter some text...';
		resizeScroller.
	
	self textMorph
		wrapFlag: false;
		acceptOnCR: true.
	
	self connect: self textMorph signal: #textEdited: toSelector: #textEdited:.
	self connect: self textMorph signal: #editingFinished: toSelector: #editingFinished:.
	self connect: self textMorph signal: #returnPressed: toSelector: #returnPressed:.! !

!UiTextEdit methodsFor: 'event handling' stamp: 'mt 9/13/2010 10:59:47.028'!
keyStroke: evt

	self acceptTextInModel.
	^ super keyStroke: evt! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:44:44.435'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 1]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/28/2010 10:26:36.223'!
outerBorderWidth: aNumber

	outerBorderWidth := aNumber.
	self redrawLater.! !

!UiTextEdit methodsFor: 'geometry' stamp: 'mt 9/22/2010 09:52:09.653'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.166'!
readOnly

	^ self textMorph readOnly! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.243'!
readOnly: aBoolean

	self textMorph readOnly: aBoolean! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 14:16:48.661'!
returnPressed: text
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'scrolling' stamp: 'mt 9/13/2010 10:59:47.59'!
scrollByKeyboard: event 

	^false! !

!UiTextEdit methodsFor: 'scrolling' stamp: 'mt 9/13/2010 10:59:47.702'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false.
	Redone here to deal with horizontal scrolling!!"
	
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	transform := scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere := transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self innerBounds) ~= (0@0) ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: delta truncated.
		^ true].
	^ false! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.778'!
textChanged: text

	self emit.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.846'!
textEdited: text
	"Not emitted if text changed programmatically."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:06:56.565'!
textMorphClass

	^ UiTextEditTextMorph! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.316'!
theText

	"self hasUnacceptedEdits
		ifTrue: [self acceptTextInModel]."

	^ text! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.389'!
theText: aValue

	aValue == text ifTrue: [^ self].
	
	text := aValue asString.
	self changed: #theText.
	
	self textChanged: text.
	self valueChanged: aValue.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.45'!
validator
	"Used for conversion purposes of input data."

	^ validator ifNil: [validator := [:raw | raw]]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.524'!
validator: aBlock
	
	validator := aBlock.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.906'!
valueChanged: convertedValue

	self emit.! !

TextMorphForEditView subclass: #UiTextEditTextMorph
	instanceVariableNames: 'autoAccept readOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

UiTextEditTextMorph subclass: #UiLineEditTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiLineEditTextMorph methodsFor: 'event handling' stamp: 'mt 9/13/2010 14:17:46.849'!
keyStroke: event
	"A line edit only supports one text line."

	event keyCharacter = Character cr
		ifTrue: [(self acceptOnCR and: [self editView hasUnacceptedEdits])
			ifTrue: [
				self editor accept.
				self editingFinished: self contents.
				self returnPressed: self contents].
			^ self].
		
	^ super keyStroke: event.! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 15:42:43.58'!
autoAccept

	^ autoAccept ifNil: [autoAccept := false]! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 15:42:43.64'!
autoAccept: anObject

	autoAccept := anObject.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 14:11:58.279'!
editingFinished: aText

	self emit.! !

!UiTextEditTextMorph methodsFor: 'macpal' stamp: 'mt 7/21/2010 20:33:37.803'!
flash

	"No flash."! !

!UiTextEditTextMorph methodsFor: 'event handling' stamp: 'mt 9/13/2010 11:35:42.471'!
keyStroke: event
	"Enable auto-accept if necessary."

	self readOnly
		ifTrue: [^ self].
		
	super keyStroke: event.
	
	self autoAccept
		ifTrue: [self editView hasUnacceptedEdits
			ifTrue: [self editor accept]].
		
	self editView convertText.
	self textEdited: self contents.! !

!UiTextEditTextMorph methodsFor: 'event handling' stamp: 'mt 9/13/2010 14:12:20.783'!
keyboardFocusChange: aBoolean

	self readOnly
		ifTrue: [self stopBlinking. ^ self].

	aBoolean
		ifFalse: [
			self editor accept.
			self editingFinished: self contents].
		
	^ super keyboardFocusChange: aBoolean! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.728'!
minExtent
	"gvc 10/17/2008 12:35 - TextMorphForFieldView ---
	Overridden to allow text to shrink to minimum extent rather than being (incorrectly)
	treated as rigid. Should be the same for other morphs too. Bah!!"

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].
	layout := self layoutPolicy.
	minExtent := layout isNil 
		ifTrue: [0 @ 0]
		ifFalse: [layout minExtentOf: self in: self layoutBounds].
	minExtent := hFit == #rigid 
		ifTrue: [self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			(minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.773'!
minHeight
	"Answer the height of one line."

	^self minimumExtent y max: super minHeight! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.817'!
minWidth
	"Answer the minimum width."

	^self minimumExtent x max: super minWidth! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.846'!
minimumExtent
	"Use the actual paragraph line to take font changes into account."
	
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt := (9@(self paragraph lines first lineHeight ceiling)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.89'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed.
	Don't adjust rightX (as in TexMorph>>paragraph)
	since wrapFlag must be false for layout to work."
	
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := (self paragraphClass new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	"don't adjust the right, let it scroll!!"
	paragraph focused: (self currentHand keyboardFocus == self).
	self fit.
self removeProperty: #CreatingParagraph.

	^ paragraph! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:25:25.325'!
readOnly

	^ readOnly ifNil: [readOnly := false]! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:28:43.603'!
readOnly: aBoolean

	readOnly := aBoolean.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 14:17:29.151'!
returnPressed: text

	self emit.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 6/29/2010 16:16:36.653'!
textEdited: text

	self emit.! !

Object subclass: #UiAbstractItemDelegate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiAbstractItemDelegate commentStamp: 'mt 10/9/2010 10:55:10.842' prior: 0!
Create morphs based on a model index. These morphs are read-only items or editors.!

!UiAbstractItemDelegate methodsFor: 'building' stamp: 'mt 10/11/2010 16:55:18.253'!
editorFor: aModelIndex
	"An editor morph must understand #accept."
	
	self subclassResponsibility.! !

!UiAbstractItemDelegate methodsFor: 'building' stamp: 'mt 10/7/2010 17:52:19.828'!
itemFor: aModelIndex

	self subclassResponsibility.! !

UiAbstractItemDelegate subclass: #UiSimpleItemDelegate
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiSimpleItemDelegate commentStamp: 'mt 10/19/2010 10:50:35.526' prior: 0!
I create simple items that consist of an image morph and a text morph layed out vertically or horizontally.!

!UiSimpleItemDelegate methodsFor: 'layouting - private' stamp: 'mt 10/14/2010 20:21:52.074'!
doLayoutFor: aMorph

	| offset |
	self orientation = #horizontal ifTrue: [
		aMorph height: aMorph submorphs last height. "for smaller items use font height"
		
		"Manual layouting."
		offset := aMorph left + 3.
		aMorph submorphs do: [:m |
			m left: offset.
			offset := offset + m width + 2.
			m top: (aMorph top - (m height - aMorph height // 2))].
	
		"Expand item horizontally to its contents."
		aMorph
			width: aMorph submorphBounds width + 5; "font rendering bugfix"
			height: aMorph height + 1. "font rendering bugfix"
		
		^ self].
	
	self orientation = #vertical ifTrue: [
		aMorph width: aMorph submorphs last width + 10.
			
		"Manual layouting."
		offset := aMorph top + 3.
		aMorph submorphs do: [:m |
			m top: offset.
			offset := offset + m height + 2.
			m left: (aMorph left - (m width - aMorph width // 2))].
	
		aMorph height: aMorph submorphBounds height + 2].! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 10/11/2010 16:52:57.182'!
editorFor: aModelIndex

	^ UiLineEdit new
		theText: aModelIndex text.! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 10/24/2010 12:31:56.852'!
itemFor: aModelIndex

	| icon text item |
	icon := aModelIndex icon "ifNil: [Morph new extent: 16@16; color: Color transparent]".
	text := aModelIndex text.
	
	(text isNil and: [icon isNil]) ifTrue: [text := ' ' asText].
	
	item := Morph new color: Color transparent.
	
	icon ifNotNil: [item addMorphBack: icon asMorph].
	text ifNotNil: [
		text isString ifTrue: [text := text asText].
		text isString | text isText ifFalse: [text := text asString asText].
		item addMorphBack: text asMorph lock].
	
	"Store morphs in properties for later access."
	item
		setProperty: #text toValue: text;
		setProperty: #icon toValue: icon.

	self doLayoutFor: item.	

	^ item! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:35.066'!
orientation

	^ orientation ifNil: [orientation := #horizontal]! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:23.964'!
orientation: aSymbol
	"#vertical, #horizontal"

	 orientation := aSymbol.! !

Object subclass: #UiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemModel commentStamp: 'mt 10/19/2010 10:48:27.86' prior: 0!
Subclass me if you want to create tree-structured models.!

UiItemModel subclass: #UiDirectoryModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiDirectoryModel commentStamp: 'mt 10/19/2010 11:04:03.304' prior: 0!
Simple model for the files structure on the harddisk. See class-side examples.!

!UiDirectoryModel class methodsFor: 'examples' stamp: 'mt 10/19/2010 11:01:04.143'!
ex01sortedTree

	UiTreeView new
		autoSortBlock: [:i1 :i2 |
			"Folder before files, sort alphabetically then. May need a change if an icon does not indicate a folder anymore."
			((i1 valueOfProperty: #icon) notNil and: [(i2 valueOfProperty: #icon) isNil])
				or: [
					(((i1 valueOfProperty: #icon) notNil and: [(i2 valueOfProperty: #icon) notNil])
						or: [(i1 valueOfProperty: #icon) isNil and: [(i2 valueOfProperty: #icon) isNil]])
						and: [(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString]]];
		model: UiDirectoryModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/7/2010 18:29:06.62'!
columnCountFor: aParentModelIndex
	"name, size, date"
	
	^ 3! !

!UiDirectoryModel methodsFor: 'accessing - data' stamp: 'mt 10/10/2010 14:52:32.637'!
iconFor: aModelIndex

	aModelIndex row = 0
		ifTrue: [^ nil].

	aModelIndex column = 1
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) isDirectory
			ifTrue: [UiSilkIcons folderIcon]
			ifFalse: [nil "UiSilkIcons pageWhiteIcon"]].
	
	aModelIndex column = 3
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) modificationDateAndTime year = 2010
			ifTrue: [UiSilkIcons newIcon]
			ifFalse: []].
		
	^ nil! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:50:53.383'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
			model: self;
			parent: aParentModelIndex].

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex;
		setProperty: #entry toValue: ((aParentModelIndex
			ifNil: [self root]
			ifNotNil: [:index | (index valueOfProperty: #entry) asFileDirectory]) entries at: aRowNumber)! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:03:33.743'!
root

	^ FileDirectory root! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/9/2010 16:45:58.07'!
rowCountFor: aParentModelIndex
	
	^ aParentModelIndex
		ifNil: [self root entries size]
		ifNotNil: [((aParentModelIndex valueOfProperty: #entry) isDirectory and: [aParentModelIndex column = 1])
			ifTrue: [(aParentModelIndex valueOfProperty: #entry) asFileDirectory entries size]
			ifFalse: [0]]! !

!UiDirectoryModel methodsFor: 'accessing - data' stamp: 'mt 10/10/2010 14:52:41.794'!
textFor: aModelIndex

	aModelIndex row = 0
		ifTrue: [
			aModelIndex column = 1 ifTrue: [^ 'Name'].
			aModelIndex column = 2 ifTrue: [^ 'Size'].
			aModelIndex column = 3 ifTrue: [^ 'Modification Date and Time']].


	aModelIndex column = 1
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) name asText].
		
	aModelIndex column = 2
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) fileSize asString asText].
		
	aModelIndex column = 3
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) modificationDateAndTime asString asText].
		
	^ nil! !

!UiItemModel methodsFor: 'counts' stamp: 'mt 10/13/2010 12:55:38.571'!
columnCountFor: aParentModelIndex

	self subclassResponsibility.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:20:34.546'!
columnsChangedFor: aParentModelIndex from: start to: end
	"Emitted whenever all model indices in some columns need are invalid."

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:12:46.124'!
columnsInsertedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:12:56.304'!
columnsRemovedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:21:09.141'!
dataChangedFrom: topLeftModelIndex to: bottomRightModelIndex

	self emit.! !

!UiItemModel methodsFor: 'testing' stamp: 'mt 10/10/2010 10:26:18.507'!
hasChildrenFor: aModelIndex

	^ (self rowCountFor: aModelIndex) > 0! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 10/13/2010 12:56:42.192'!
iconFor: aModelIndex

	^ nil! !

!UiItemModel methodsFor: 'index generation' stamp: 'mt 10/13/2010 13:02:11.53'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex
	"A 'nil' parent indicates the root node. Vertical header indices have 'aColumnNumber = 0'; horizontal header indices have 'aRowNumber = 0'."
	
	self subclassResponsibility.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 12:54:02.23'!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!UiItemModel methodsFor: 'initialization' stamp: 'mt 10/13/2010 12:57:50.04'!
reset

	self modelReset.! !

!UiItemModel methodsFor: 'counts' stamp: 'mt 10/13/2010 12:55:43.688'!
rowCountFor: aParentModelIndex

	self subclassResponsibility.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:20:20.707'!
rowsChangedFor: aParentModelIndex from: start to: end
	"Emitted whenever all model indices in some rows need are invalid."
	
	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:13:06.617'!
rowsInsertedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:13:02.4'!
rowsRemovedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 10/13/2010 12:56:45.936'!
textFor: aModelIndex

	^ nil! !

UiItemModel subclass: #UiListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiListModel commentStamp: 'mt 10/19/2010 10:46:42.816' prior: 0!
A simple version of the generic model that only supports 1 column. Subclass it and implement #rowCount, #textAt:, and #iconAt: to create a simple list model.!

UiListModel subclass: #UiIconModel
	instanceVariableNames: 'iconSet showText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiIconModel commentStamp: 'mt 10/14/2010 19:53:08.979' prior: 0!
Supports all subclasses of UiIcons as #iconSet.!

!UiIconModel class methodsFor: 'examples' stamp: 'mt 10/19/2010 11:06:47.58'!
ex01silk

	UiListIconView new
		listOrientation: #vertical;
		model: (UiIconModel new
			iconSet: UiSilkIcons;
			showText: false);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel class methodsFor: 'examples' stamp: 'mt 10/19/2010 11:07:06.686'!
ex02silkWithText

	UiListIconView new
		listOrientation: #vertical;
		model: (UiIconModel new
			iconSet: UiSilkIcons;
			showText: true);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 20:38:17.087'!
codeSnippetFor: aModelIndex

	aModelIndex ifNil: [^ ''].
	
	^ self iconSet name, ' ', (self iconSelectors at: aModelIndex row)! !

!UiIconModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:49:44.229'!
iconAt: anIndex

	^ self iconSet perform: (self iconSelectors at: anIndex)! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 20:36:36.757'!
iconSelectors

	self iconSet ifNil: [^ #()].
	^ self iconSet class organization listAtCategoryNamed: #accessing! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:45:12.099'!
iconSet

	^ iconSet! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:44:20.126'!
iconSet: anIconSet

	iconSet := anIconSet.
	self reset.! !

!UiIconModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:48:31.26'!
rowCount

	^ self iconSelectors size! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:58:51.741'!
showText

	^ showText ifNil: [showText := true]! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:58:43.53'!
showText: aBoolean

	showText := aBoolean.
	self reset.! !

!UiIconModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:59:09.323'!
textAt: anIndex

	^ self showText
		ifFalse: [nil]
		ifTrue: [(self iconSelectors at: anIndex) allButLast: 4 "remove icon suffix"]! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:38:56.514'!
columnCountFor: aParentModelIndex

	^ 1! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:47:02.848'!
iconAt: anRow

	self subclassResponsibility.! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:46:47.469'!
iconFor: aModelIndex

	^ self iconAt: aModelIndex row! !

!UiListModel methodsFor: 'index generation' stamp: 'mt 10/14/2010 19:43:12.236'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:39:44.025'!
rowCount

	self subclassResponsibility.! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:39:33.408'!
rowCountFor: aParentModelIndex

	^ self rowCount! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:47:07.721'!
textAt: anRow

	self subclassResponsibility.! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:53:37.273'!
textFor: aModelIndex

	^ self textAt: aModelIndex row! !

UiListModel subclass: #UiListWidgetModel
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetModel commentStamp: 'mt 10/20/2010 14:12:24.921' prior: 0!
I am the hidden model used in the item-based UiListWidget.!

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:02:09.394'!
addItem: aListWidgetItem

	self items add: aListWidgetItem.
	aListWidgetItem model: self.
	
	self triggerItemAddedAt: (self items indexOf: aListWidgetItem).! !

!UiListWidgetModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:38:05.057'!
iconAt: integer

	^ (self items at: integer) icon! !

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:37:20.66'!
items

	^ items ifNil: [items := OrderedCollection new]! !

!UiListWidgetModel methodsFor: 'counts' stamp: 'mt 10/19/2010 19:37:11.329'!
rowCount

	^ self items size! !

!UiListWidgetModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:37:49.039'!
textAt: integer

	^ (self items at: integer) text! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:55:58.253'!
triggerItemAddedAt: index

	self rowsInsertedFor: nil from: index to: index.! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:56:13.227'!
triggerItemChangedAt: index

	self rowsChangedFor: nil from: index to: index.! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:56:25.038'!
triggerItemRemovedAt: index

	self rowsRemovedFor: nil from: index to: index.! !

UiItemModel subclass: #UiSmalltalkModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiSmalltalkModel commentStamp: 'mt 10/19/2010 11:04:26.59' prior: 0!
More complex model to navigate the Smalltalk system structure. See class-side examples.!

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:19:54.048'!
ex01iconicList

	UiListIconView new
		listOrientation: #vertical;
		defaultItemDelegate: (UiSimpleItemDelegate new orientation: #vertical);
		hAlignment: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 17:59:12.416'!
ex02tree

	UiTreeView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:23:15.693'!
ex03table

	UiTableView new
		setHAlignmentForColumn: 2 to: #right;
		setHAlignmentForColumn: 3 to: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:28:40.411'!
ex04simpleList

	UiListIconView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:29:45.034'!
ex05horizontalList

	UiListIconView new
		listOrientation: #horizontal;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel methodsFor: 'counts' stamp: 'mt 10/11/2010 16:30:56.086'!
columnCountFor: aParentModelIndex
	"name, childCount, type"
	
	^ 3! !

!UiSmalltalkModel methodsFor: 'model data' stamp: 'mt 10/11/2010 16:34:34.161'!
iconFor: aModelIndex

	| col package systemCategory class protocol method |
	col := aModelIndex column.
	package := aModelIndex valueOfProperty: #package ifAbsent: [].
	systemCategory := aModelIndex valueOfProperty: #systemCategory  ifAbsent: [].
	class := aModelIndex valueOfProperty: #class ifAbsent: [].
	protocol := aModelIndex valueOfProperty: #protocol ifAbsent: [].
	method := aModelIndex valueOfProperty: #method ifAbsent: [].
	
	"Horizontal headers."
	aModelIndex row = 0 ifTrue: [
		col = 1 ifTrue: [^ UiSilkIcons fontIcon].
		col = 2 ifTrue: [^ UiSilkIcons chartBarIcon].
		col = 3 ifTrue: [^ UiSilkIcons informationIcon]].
	
	package ifNotNil: [:p | 
		col = 1 ifTrue: [^ UiSilkIcons packageIcon]].
	
	"systemCategory ifNotNil: [:cat | ].
	
	class ifNotNil: [:c |].

	protocol ifNotNil: [:p | ].
	
	method ifNotNil: [:m | ]."
		
	^ nil! !

!UiSmalltalkModel methodsFor: 'index generation' stamp: 'mt 10/10/2010 14:19:12.733'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| index |
	index := (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex.
	
	"Header indices."
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ index].
	
	aParentModelIndex ifNil: [
		index setProperty: #package toValue: (PackageOrganizer default packages at: aRowNumber).
		^ index].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		index
			setProperty: #systemCategory
			toValue: ((aParentModelIndex valueOfProperty: #package) systemCategories at: aRowNumber).
		index
			setProperty: #systemCategoryPrefix
			toValue: (aParentModelIndex valueOfProperty: #package) systemCategoryPrefix.
		^ index].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		index
			setProperty: #class
			toValue: ((SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory))
				at: aRowNumber).
		^ index].
	
	(aParentModelIndex includesProperty: #class) ifTrue: [ | class |
		class := Smalltalk at: (aParentModelIndex valueOfProperty: #class).
		index
			setProperty: #organization
			toValue: class organization.
		index
			setProperty: #protocol
			toValue: (class organization categories at: aRowNumber).
		^ index].

	(aParentModelIndex includesProperty: #protocol) ifTrue: [ | organization protocol |
		organization := aParentModelIndex valueOfProperty: #organization.
		protocol := aParentModelIndex valueOfProperty: #protocol.
		index
			setProperty: #method
			toValue: ((organization listAtCategoryNamed: protocol) at: aRowNumber).
		^ index].! !

!UiSmalltalkModel methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:36:09.409'!
initialize

	"SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:."! !

!UiSmalltalkModel methodsFor: 'notifications' stamp: 'mt 10/14/2010 11:43:56.986'!
processNotification: anEvent

	| pkg pkgIndex sysIndex classIndex |
	(anEvent itemKind ~= #category and: [anEvent itemKind ~= #class])
		ifTrue: [^ self].
	
	pkg := PackageOrganizer default
		packageOfSystemCategory: anEvent itemCategory
		ifNone: [^ self].
	pkgIndex := (UiSimpleModelIndex
		row: (PackageOrganizer default packages indexOf: pkg)
		column: 1)
		model: self;
		setProperty: #package toValue: pkg.
	sysIndex := self
		indexRow: (pkg systemCategories indexOf: anEvent itemCategory)
		column: 1
		parent: pkgIndex.
	classIndex := self
		indexRow: ((SystemOrganization listAtCategoryNamed: anEvent itemCategory) indexOf: anEvent itemClass name)
		column: 1
		parent: sysIndex.
	
	anEvent itemKind = #category ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRenamed ifTrue: [
			sysIndex := self
				indexRow: (pkg systemCategories indexOf: anEvent newName)
				column: 1
				parent: pkgIndex.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]].

	anEvent itemKind = #class ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row].
		anEvent isRenamed ifTrue: [
			self rowsChangedFor: sysIndex from: classIndex row to: classIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]
		].
	
	anEvent itemKind = #method ifTrue: [
		].! !

!UiSmalltalkModel methodsFor: 'counts' stamp: 'mt 10/10/2010 14:13:30.029'!
rowCountFor: aParentModelIndex
	
	aParentModelIndex ifNil: [
		^ PackageOrganizer default packages size].
	
	aParentModelIndex column ~= 1 ifTrue: [^ 0].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		^ (aParentModelIndex valueOfProperty: #package) systemCategories size].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		^ (SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory)) size].
	
	(aParentModelIndex includesProperty: #class) ifTrue: [ | class |
		^ (Smalltalk at: (aParentModelIndex valueOfProperty: #class)) organization categories size].

	(aParentModelIndex includesProperty: #protocol) ifTrue: [ | organization protocol |
		organization := aParentModelIndex valueOfProperty: #organization.
		protocol := aParentModelIndex valueOfProperty: #protocol.
		^ (organization listAtCategoryNamed: protocol) size].
	
	^ 0! !

!UiSmalltalkModel methodsFor: 'model data' stamp: 'mt 10/14/2010 13:26:32.98'!
textFor: aModelIndex

	| col package systemCategory class protocol method |
	col := aModelIndex column.
	package := aModelIndex valueOfProperty: #package ifAbsent: [].
	systemCategory := aModelIndex valueOfProperty: #systemCategory  ifAbsent: [].
	class := aModelIndex valueOfProperty: #class ifAbsent: [].
	protocol := aModelIndex valueOfProperty: #protocol ifAbsent: [].
	method := aModelIndex valueOfProperty: #method ifAbsent: [].
	
	"Horizontal headers."
	aModelIndex row = 0 ifTrue: [
		col = 1 ifTrue: [^ '<b>Name</b>' asHtmlText].
		col = 2 ifTrue: [^ '<b>Size</b>' asHtmlText].
		col = 3 ifTrue: [^ '<b>Type</b>' asHtmlText]].
	
	"Vertical headers."
	aModelIndex column = 0 ifTrue: [
		^ aModelIndex row asString].
	
	package ifNotNil: [:p | 
		col = 1 ifTrue: [^ p name].
		col = 2 ifTrue: [^ ('<font color="#555555">', p systemCategories size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">package</font>' asHtmlText]].
	
	systemCategory ifNotNil: [:cat | 
		| prefix |
		prefix := aModelIndex valueOfProperty: #systemCategoryPrefix.
		
		col = 2 ifTrue: [^ ('<font color="#555555">', (SystemOrganization listAtCategoryNamed: cat) size asString, '</font>') asHtmlText].
		
		cat = prefix ifFalse: [cat := cat allButFirst: prefix size + 1].
		col = 1 ifTrue: [^ cat].
		col = 3 ifTrue: [^ '<font color="#555555">system category</font>' asHtmlText]].
	
	class ifNotNil: [:c |
		col = 1 ifTrue: [^ c].
		col = 2 ifTrue: [^ ('<font color="#555555">', (Smalltalk at: c) organization categories size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">class</font>' asHtmlText]].

	protocol ifNotNil: [:p |
		| organization |
		organization := aModelIndex valueOfProperty: #organization.
		col = 1 ifTrue: [^ p].
		col = 2 ifTrue: [^ ('<font color="#555555">', (organization listAtCategoryNamed: p) size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">protocol</font>' asHtmlText]].
	
	method ifNotNil: [:m |
		col = 1 ifTrue: [^ '#', m].
		col = 3 ifTrue: [^ '<font color="#555555">method</font>' asHtmlText]].
		
	^ nil! !

UiItemModel subclass: #UiTableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTableModel commentStamp: 'mt 10/24/2010 11:09:38.118' prior: 0!
An abstract base class for a table-like model. Implement #rowCount and #columnCount and the data accessing functions, e.g., #textFor: and #iconFor:.!

UiTableModel subclass: #UiRessourceMonitorModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiRessourceMonitorModel methodsFor: 'counts' stamp: 'mt 10/24/2010 12:17:47.645'!
columnCount

	^ self data first size! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 10/24/2010 21:11:58.286'!
data

	^ {
		{'world submorphs'. [ActiveWorld submorphs size]. nil. 'The number of all submorphs in the active world (<b>PasteUpMorph</b>)' asHtmlText}.
		{'event handlers'. [EventHandler allInstances size]. 2000. 'The number of all <b>EventHandler</b> instances.' asHtmlText}.
		{'morphic designers'. [UiDesigner allInstances size]. 1. 'The number of all <b>UiDesigner</b> instances.' asHtmlText}.
		{'signal emitters'. [SignalConnectionsRepository instance size]. 500. 'The number of all registered objects that have signals connected to somewhere.'}.
		{'icons'. Form allInstances count: [:f | f extent = (16@16)]. nil. 'The number of all 16x16 forms.'}.
		{'packages'. [PackageOrganizer default packages size]. nil. 'The number of all packages in this image.'}.
		{'classes'. [Smalltalk allClasses size]. nil. 'The number of all classes in this image.'}.
		{'traits'. [Smalltalk allTraits size]. nil. 'The number of all traits in this image.'}.
		{'system change sends'. [((SystemChangeNotifier uniqueInstance instVarNamed: #eventSource) actionMap values collect: [:list | list size]) sum]. nil. 'The number of all targets if a system change event occurs.'}}! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 10/24/2010 12:26:46.923'!
iconFor: aModelIndex

	aModelIndex row = 0 ifTrue: [^ nil].
	
	aModelIndex column = 3 ifTrue: [
		| threshold value |
		threshold := (self data at: aModelIndex row) at: 3.
		value := ((self data at: aModelIndex row) at: 2) value.
		(threshold notNil and: [value > threshold])
			ifTrue: [^ UiDiagonaIcons icon0150Normal]
			ifFalse: [^ UiSilkIcons acceptIcon]].
	
	^ nil! !

!UiRessourceMonitorModel methodsFor: 'counts' stamp: 'mt 10/24/2010 12:17:29.637'!
rowCount

	^ self data size! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 10/24/2010 12:21:47.164'!
textFor: aModelIndex

	aModelIndex row = 0 ifTrue: [
		aModelIndex column = 1 ifTrue: [^ 'Ressource'].
		aModelIndex column = 2 ifTrue: [^ 'Value'].
		aModelIndex column = 3 ifTrue: [^ 'Threshold'].
		aModelIndex column = 4 ifTrue: [^ 'Comments']].
	
	aModelIndex column = 0 ifTrue: [^ nil].
	

	^ ((self data at: aModelIndex row) at: aModelIndex column) value! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:41.824'!
columnCount

	self subclassResponsibility.! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:46:02.014'!
columnCountFor: aParentModelIndex

	^ self columnCount! !

!UiTableModel methodsFor: 'index generation' stamp: 'mt 10/19/2010 10:47:07.46'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:38.172'!
rowCount

	self subclassResponsibility.! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:51.277'!
rowCountFor: aParentModelIndex

	^ self rowCount! !

Object subclass: #UiItemOrder
	instanceVariableNames: 'map sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemOrder commentStamp: 'mt 10/16/2010 14:45:30.134' prior: 0!
A cached order of some items. Needs to be updated frequently.!

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 19:08:23.107'!
items: someItems at: anIndex
	
	self map ifNil: [^ someItems at: anIndex].
	^ someItems at: (self map at: anIndex)! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:57.143'!
items: someItems collect: aBlock

	self map ifNil: [^ someItems collect: aBlock].
	^ map collect: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:42.612'!
items: someItems do: aBlock

	self map ifNil: [^ someItems do: aBlock].
	map do: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 19:12:41.82'!
items: someItems withIndexDo: aBlock

	self map ifNil: [^ someItems withIndexDo: aBlock].
	map do: [:index | aBlock value: (someItems at: index) value: index]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:00.465'!
map

	^ map! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:44.975'!
map: anArray
	"Example: #(5 4 3 2 1) will revert a list with 5 items."

	map := anArray.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:11:53.792'!
mapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map at: anIndex! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:04:46.949'!
sortBlock

	^ sortBlock! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:44:45.717'!
sortBlock: aBlock

	sortBlock := aBlock.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:12:05.571'!
unmapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map indexOf: anIndex! !

!UiItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 15:05:08.919'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

UiItemOrder subclass: #UiTreeItemOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:57:52.003'!
parent: currentParent list: aList result: result

	aList do: [:each |
		| index |
		index := each valueOfProperty: #modelIndex.
		index parent = currentParent ifTrue: [
			result add: each.
			self parent: index list: (aList copyWithout: each) result: result]].! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:59:59.151'!
rebuildTreeStructure: items

	| result |
	result := OrderedCollection new.
	self parent: nil list: items result: result.
	^ result! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 19:00:21.046'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	sortedCopy := self rebuildTreeStructure: sortedCopy.
	
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

Object subclass: #UiListWidgetItem
	instanceVariableNames: 'icon text enabled model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetItem commentStamp: 'mt 6/28/2010 17:06:54.526' prior: 0!
Container for item information to be used by UiListWidget.!

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 21:22:12.894'!
enabled

	^ enabled ifNil: [enabled := true]! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:05:01.021'!
enabled: aBoolean

	enabled := aBoolean.
	self triggerItemChanged.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 17:08:41.322'!
icon
	^ icon! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:05:09.972'!
icon: anObject

	icon := anObject.
	self triggerItemChanged.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:02:38.97'!
model

	^ model! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:02:44.327'!
model: aModel

	model := aModel.! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 17:08:41.407'!
text
	^ text! !

!UiListWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:04:56.723'!
text: anObject

	text := anObject.
	self triggerItemChanged.! !

!UiListWidgetItem methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 20:04:48.802'!
triggerItemChanged

	self model ifNotNil: [:m |
		m triggerItemChangedAt: (m items indexOf: self)].! !

Object subclass: #UiViewInfo
	instanceVariableNames: 'size items resizeMode headerItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

UiViewInfo subclass: #UiViewColumnInfo
	instanceVariableNames: 'vAlignment hAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewColumnInfo commentStamp: 'mt 10/9/2010 11:38:45.048' prior: 0!
Useful index element for tree viewport.!

!UiViewColumnInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:31:56.097'!
formatHeaderItem

	| backgroundColor |
	backgroundColor := Color gray: 0.85.
	headerItem
		vResizing: #spaceFill;
		fillStyle: ((GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (backgroundColor adjustBrightness: 0.05).
			0.6 -> (backgroundColor darker)})
			origin: headerItem topLeft;
			direction: 0 @ headerItem height);
		borderStyle: (BorderStyle raised width: 1).! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:25.869'!
hAlignment

	^ hAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:34.152'!
hAlignment: aSymbol

	hAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:08:54.097'!
initialize

	super initialize.
	self
		resize: 150;
		vAlignment: #top;
		hAlignment: #left.! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:53:10.558'!
optimalSize
	"Return the width of the largest item."
	
	| max |
	max := 0.
	items do: [:item | 
		item hResizing ~= #spaceFill
			ifTrue: [max := max max: (item width + (item valueOfProperty: #indent))]].
	self headerItem submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds width + 5. "font rendering bugfix" ].
	^ max! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 10/11/2010 16:28:52.324'!
resize: anInteger

	super resize: anInteger.
	self headerItem width: anInteger.
	self items do: [:item | 
		item hResizing = #spaceFill
			ifTrue: [item width: self width]].! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:11.098'!
vAlignment

	^ vAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:17.674'!
vAlignment: aSymbol

	vAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:52:12.794'!
width

	^ size! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:15:41.705'!
width: anInteger

	self resize: anInteger.! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:51:31.693'!
clear

	items removeAll.! !

!UiViewInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:28:47.076'!
formatHeaderItem! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:46:28.423'!
headerItem

	^ headerItem! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:52:28.016'!
headerItem: aMorph
		
	headerItem := aMorph.
	self formatHeaderItem.! !

!UiViewInfo methodsFor: 'testing' stamp: 'mt 10/9/2010 19:57:43.188'!
includes: aModelIndex

	^ items anySatisfy: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 16:38:47.653'!
initialize

	super initialize.
	
	items := OrderedCollection new.
	resizeMode := #shrinkWrap.
	
	self headerItem: (Morph new extent: 5@5). "dummy header item"! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/13/2010 15:42:39.671'!
itemAt: aModelIndex

	^ items detect: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 18:19:16.151'!
itemBefore: anItem

	^ items before: anItem ifAbsent: []! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 19:58:04.261'!
itemIndexFor: aModelIndex

	items withIndexDo: [:item :index |
		(item valueOfProperty: #modelIndex) = aModelIndex
			ifTrue: [^ index]].
	
	Error signal: 'Not found.'.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:13:57.129'!
items

	^ items! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/9/2010 18:16:09.336'!
optimalSize

	self subclassResponsibility.	! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/10/2010 12:50:22.763'!
resize: aNumber

	size := aNumber.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:09:54.303'!
resizeMode

	^ resizeMode! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:09:57.107'!
resizeMode: aSymbol
	"#rigid, #shrinkWrap, #spaceFill"

	resizeMode := aSymbol.! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/9/2010 18:18:18.674'!
updateSize

	self resizeMode = #shrinkWrap
		ifTrue: [self resize: self optimalSize].! !

UiViewInfo subclass: #UiViewRowInfo
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewRowInfo commentStamp: 'mt 10/9/2010 11:38:35.657' prior: 0!
Useful index element for tree viewport.!

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:21:06.63'!
firstModelIndex
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [(items first valueOfProperty: #modelIndex)]! !

!UiViewRowInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:37:25.357'!
formatHeaderItem

	| backgroundColor |
	backgroundColor := Color gray: 0.85.
	headerItem
		hResizing: #spaceFill;
		fillStyle: ((GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (backgroundColor adjustBrightness: 0.05).
			0.6 -> (backgroundColor darker)})
			origin: headerItem topLeft;
			direction: headerItem width @ 0);
		borderStyle: (BorderStyle raised width: 1).! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:51:44.846'!
height

	^ size! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:20:41.803'!
height: anInteger

	self resize: anInteger.! !

!UiViewRowInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 18:47:11.649'!
initialize

	super initialize.
	self resize: Preferences standardListFont height.! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:44.554'!
isCollapsed

	^ self isExpanded not! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:36.67'!
isExpanded

	^ items notEmpty and: [items first valueOfProperty: #isExpanded]! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:53:29.205'!
optimalSize
	"Return the height of the largest item."
	
	| max |
	max := 0.
	items do: [:item |
		item vResizing ~= #spaceFill
			ifTrue: [max := max max: item height]].
	self headerItem submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds height].
	^ max! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 12:36:24.14'!
parentModelIndex
	"All items in a row should have the same parent model index. So take the first item to access."
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [(items first valueOfProperty: #modelIndex) parent]! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 10/11/2010 16:29:08.358'!
resize: anInteger

	super resize: anInteger.
	self headerItem height: anInteger.
	self items do: [:item | 
		item vResizing = #spaceFill
			ifTrue: [item height: self height]].! !

Object subclass: #UiViewSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

UiViewSelection subclass: #UiViewExtendedSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

UiViewSelection subclass: #UiViewMultiSelection
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewMultiSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:58:34.066'!
add: aCellIndex event: aUserInputEvent

	"Invert the cell."
	self cells
		remove: aCellIndex
		ifAbsent: [self cells add: aCellIndex].
		
	self selectionChanged.! !

!UiViewMultiSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:56:08.346'!
cells

	^ cells ifNil: [cells := Set new]! !

UiViewSelection subclass: #UiViewNullSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewNullSelection commentStamp: 'mt 10/11/2010 14:09:45.699' prior: 0!
No selection of cells possible.!

!UiViewNullSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 14:09:04.349'!
add: aCellIndex event: aUserInputEvent

	"Ignore."! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:50.077'!
cells

	^ #()! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:00.921'!
currentCell

	^ nil! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:08.721'!
currentCell: anIndex

! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 09:07:25.205'!
add: aCellIndex event: aUserInputEvent! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 09:13:15.101'!
cells
	"Return an array with all selected cells."
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:02.818'!
clear
! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:15:39.961'!
currentCell
	"Return the current cell. Normally the last added one."

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:23:46.96'!
currentCell: aPoint

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 10/16/2010 14:26:07.47'!
currentCellChanged

	self emit.! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 10/11/2010 09:12:03.242'!
selectionChanged

	self emit.! !

UiViewSelection subclass: #UiViewSingleSelection
	instanceVariableNames: 'selectedCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/20/2010 14:42:59.222'!
add: aCellIndex event: aUserInputEvent

	selectedCell := aCellIndex.
	self
		selectionChanged;
		currentCellChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:35:26.499'!
cells

	^ selectedCell
		ifNil: [#()]
		ifNotNil: [{selectedCell}]! !

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:25.989'!
clear

	selectedCell := nil.
	self selectionChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:16:06.717'!
currentCell

	^ selectedCell! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:26:19.682'!
currentCell: aPoint

	selectedCell := aPoint.
	self currentCellChanged.! !

Object subclass: #UserInterface
	instanceVariableNames: 'panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UserInterface commentStamp: 'mt 6/27/2010 09:43:15.463' prior: 0!
I am the abstract base class of an auto-generated User Interface.!

UserInterface subclass: #FuzzyUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Custom'!

!FuzzyUi methodsFor: 'ui - private' stamp: 'mt 10/22/2010 11:57:16.488'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel extent: (396@547).
	panel position: (372@105).
	panel hResizing: (#spaceFill).
	panel vResizing: (#spaceFill).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiCheckBox new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (74@21).
	unnamedMorph1 position: (445@211).
	unnamedMorph1 hResizing: (#shrinkWrap).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (2@0 corner: 2@0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 icon: (nil).
	unnamedMorph1 text: ('CheckBox').
	unnamedMorph1 checkable: (true).
	unnamedMorph1 checked: (false).
	unnamedMorph1 autoExclusive: (false).
	panel addMorphBack: unnamedMorph1.
	unnamedMorph2 := UiPushButton new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (42@21).
	unnamedMorph2 position: (537@298).
	unnamedMorph2 hResizing: (#shrinkWrap).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (2@0 corner: 2@0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 icon: (UiSilkIcons acceptIcon).
	unnamedMorph2 text: ('OK').
	unnamedMorph2 checkable: (false).
	unnamedMorph2 checked: (false).
	unnamedMorph2 autoExclusive: (false).
	panel addMorphBack: unnamedMorph2.
	unnamedMorph3 := UiToolButton new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (66@21).
	unnamedMorph3 position: (482@364).
	unnamedMorph3 hResizing: (#shrinkWrap).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (2@0 corner: 2@0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 icon: (nil).
	unnamedMorph3 text: ('ToolButton').
	unnamedMorph3 checkable: (false).
	unnamedMorph3 checked: (false).
	unnamedMorph3 autoExclusive: (false).
	unnamedMorph3 autoRaise: (false).
	unnamedMorph3 buttonStyle: (#textBesideIcon).
	panel addMorphBack: unnamedMorph3.
	panel setProperty: #uiClassName toValue: 'Fuzzy'.! !

UserInterface subclass: #UnknownUi
	instanceVariableNames: 'blubb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Custom'!

!UnknownUi methodsFor: 'accessing' stamp: 'mt 10/19/2010 16:41:10.712'!
blubb
	"nil"
	
	^ blubb! !

!UnknownUi methodsFor: 'ui - private' stamp: 'mt 10/19/2010 16:41:10.781'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel extent: 395@547.
	panel position: 358@108.
	panel hResizing: #spaceFill.
	panel vResizing: #spaceFill.
	panel cellInset: 4.
	panel cellPositioning: #center.
	panel cellSpacing: #none.
	panel layoutInset: 4.
	panel listCentering: #topLeft.
	panel listDirection: #topToBottom.
	panel listSpacing: #none.
	panel maxCellSize: 1073741823.
	panel minCellSize: 0.
	panel wrapCentering: #topLeft.
	panel wrapDirection: #none.
	panel setProperty: #objectName toValue: 'panel'.
	blubb := UiPushButton new.
	blubb changeTableLayout.
	blubb extent: 88@21.
	blubb position: 450@199.
	blubb hResizing: #shrinkWrap.
	blubb vResizing: #shrinkWrap.
	blubb cellInset: 4.
	blubb cellPositioning: #center.
	blubb cellSpacing: #none.
	blubb layoutInset: 2@0 corner: 2@0.
	blubb listCentering: #topLeft.
	blubb listDirection: #leftToRight.
	blubb listSpacing: #none.
	blubb maxCellSize: 1073741823.
	blubb minCellSize: 0.
	blubb wrapCentering: #topLeft.
	blubb wrapDirection: #none.
	blubb text: 'PushButton'.
	blubb setProperty: #objectName toValue: 'blubb'.
	blubb setProperty: #objectDescription toValue: 'A test.'.
	panel addMorphBack: blubb.
	panel setProperty: #uiClassName toValue: 'Unknown'.! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:48:47.906'!
initializePanel
	"Subclass will contain auto-generated code for this."
	
	self subclassResponsibility.! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:45:06.967'!
panel
	"Returns the root panel for this UI."
	
	^ panel! !

!UserInterface methodsFor: 'ui - general' stamp: 'mt 10/28/2010 11:17:21.192'!
setupUi: aMorph
	"Configures this UI to be used in the given morph."
	
	self initializePanel.
	
	aMorph extent < self panel extent
		ifTrue: [aMorph extent: self panel extent].
	
	aMorph
		changeTableLayout;
		color: self panel color;
		addMorphBack: self panel.! !

!Form methodsFor: '*widgets-support' stamp: 'mt 9/2/2010 11:52:12.191'!
asGrayScale2

	^ self collectColors: [:c | c isTransparent
		ifTrue: [c]
		ifFalse: [Color gray: c luminance]]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 7/16/2010 13:08:02.826'!
clippedTo: aPoint
 	"Return a copy of this form that is clipped to the given size around the center."
	
	| newForm |
	newForm := self class extent: aPoint depth: depth.
	^ newForm copyBits: ((0@0 corner: aPoint) translateBy: (self extent - aPoint) // 2) from: self at: 0@0
		clippingBox: newForm boundingBox rule: Form over fillColor: nil! !
